/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(!dojo._hasResource['epages.cartridges.de_epages.product.widget.ProductImages']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.product.widget.ProductImages'] = true;
/*
  Copyright (c) 2006-2009, ePages GmbH
  All Rights Reserved.

  epages.cartridges.de_epages.design.widget.ProductImages $Revision: 1.19 $

*/

dojo.provide('epages.cartridges.de_epages.product.widget.ProductImages');



epages.require('ep_mediagallery', 'epages.cartridges.de_epages.mediagallery.widget.Mediagallery');

(function(jq){

dojo.declare(
  "epages.cartridges.de_epages.product.widget.ProductImages",
  [epages.widget.LocalizedWidget],
  {
    /**
     * public properties
     */
    objectId            : "",
    uploadAction        : "",
    scaleParams         : "",
    siteId              : epages.vars.SiteID,
    url                 : '?',
    setProductImages    : true,
    multiSelect         : "true",
    big                 : "true",
    reloadAfterUpload   : "true",
    filePath            : "",
    fileAttribute       : "",
    fileName            : "",
    infoText            : "",
    confirm             : "",
    objectId            : epages.vars.ObjectID || '',

    deleteAction        : undefined,
    deleteWidgetDojoType: 'epages.widget.DeleteFileAttributesOnServer',

    /**
     * template properties
     */

    templateType       : 'default',
    defaultTemplateType: 'default',
    _templateMapping: {
      'default'     : {templateString:"<div class=\"ProductImages\">\n  <div class=\"ClearBoth\">\n    <input type=\"file\" class=\"NoButtonTrigger\" dojoAttachpoint=\"uploadAppletNode\"/>\n  </div>\n</div>\n"},
      'withpreview' : {templateString:"<div class=\"ProductImages WithPreview\">\n  <table style=\"border:0\">\n    <tr>\n      <td style=\"border:0;width:100px;\">\n        <span dojoAttachPoint=\"slidesWidget\"\n              dojoType=\"epages.widget.Slides\"\n              imageHeight=\"100px\" imageWidth=\"100px\"\n              stopped=\"true\"\n              showControls=\"false\"\n              showMisc=\"false\"\n              showDescription=\"false\">\n          <ins dojoAttachPoint=\"slidesWidgetIns\" image=\"\"></ins>\n        </span>\n        <span class=\"ToolTip ep-js\" data-js=\".uiTooltip({})\">\n          <div dojoAttachPoint=\"nameNode\" class=\"Bold\">${fileName}</div>\n          <div dojoAttachPoint=\"infoNode\">${infoText}</div>\n        </span>\n      </td>\n      <td style=\"border:0;\">\n        <div class=\"LeftMargin\" style=\"height:100px;position:relative\">\n          <div class=\"ClearBoth\">\n          <input type=\"file\" class=\"NoButtonTrigger\" dojoAttachpoint=\"uploadAppletNode\"/>\n          </div>\n          <div dojoAttachEvent=\"onclick:_openMediaGallery\" class=\"ClearBoth HideElement\">\n            <span class=\"FloatLeft Button EnableHover\">\n              <span class=\"ButtonIconContainer\">\n                <i class=\"Sprite ico_s_openfile\"></i>\n              </span>\n              <u class=\"ButtonContainer ButtonIconPadding\">{MediaGallery}...</u>\n            </span>\n          </div>\n      <div class=\"ClearBoth\"></div>\n          <span dojoType=\"${deleteWidgetDojoType}\"\n            dojoAttachPoint=\"deleteNode\"\n            fileAttribute=\"${fileAttribute}\"\n            filePath=\"${filePath}\"\n            fileName=\"${fileName}\"\n            confirm=\"true\"\n            objectId=\"${objectId}\"\n            style=\"position:relative;top:60px;\"\n            changeAction=\"DeleteMultipleFiles\"\n            class=\"ChangeLink HideElement\"\n          ></span>\n        </div>\n      </td>\n    </tr>\n  </table>\n</div>\n"}
    },

    templateString:"<div class=\"ProductImages\">\n  <div class=\"ClearBoth\">\n    <input type=\"file\" class=\"NoButtonTrigger\" dojoAttachpoint=\"uploadAppletNode\"/>\n  </div>\n</div>\n",
    translationName    : dojo.moduleUrl('epages.cartridges.de_epages.product.widget' , 'templates/translation'),
    /**
     * widget properties
     */
    imagePath         : epages.themeUrl('images'),
    widgetsInTemplate : true,

    postMixInProperties: function() {
      this._templateDirectory = dojo.moduleUrl('epages.cartridges.de_epages.product.widget','templates');
      this.inherited("postMixInProperties", arguments);
      this.uploadAction = this.uploadAction+'&'+this.scaleParams;
      this.setProductImages = epages.string.toBoolean(this.setProductImages);
    },

    postCreate: function() {
      this.inherited("postCreate", arguments);

       if(this.slidesWidgetIns && this.filePath && this.fileName) {
         this.slidesWidgetIns.image = this.filePath + this.fileName;
       }

      if (this.deleteNode) {
         this.deleteNode.onSuccess = dojo.hitch(this, 'onDelete');
          if(this.deleteAction) {
            this.deleteNode.changeAction = deleteAction;
          }
      }

        // set id for uploader
        this.uploadAppletNode.id = this.id+'_uploader';
        dojo.subscribe(this.uploadAppletNode.id + "/onUploadFinished", this, 'onUploadProductImage');
        if (this.deleteNode) {
          this.deleteNode.onSuccess = dojo.hitch(this, 'onDelete');
        }

        var self = this,
          ViewAction = /(?:^|\?|&)ViewAction=(.*?)(?:&|$)/.exec(this.uploadAction);

	      if(!this.hideUploader){
	        de_epages(this.uploadAppletNode)
	          .presentationUiUploader({
	            url:    this.uploadAction+'&'+this.scaleParams,
	            data:   {
	              'ViewAction': ViewAction ? ViewAction[1] : 'JSONViewResponse'
	            },
	            multiple: this.multiSelect,
	            accept:   'image/*',
	            callback: this.reloadAfterUpload==='true' || this.reloadAfterUpload===true ? '?ViewAction='+ep.config.viewAction+'&ObjectID='+ep.config.objectId : function( data ){
	              dojo.publish( self.uploadAppletNode.id + '/onUploadFinished', [data[0].success || data[0].ERROR || {}] );
	            }
	          });
	      }

    },

    onDelete: function() {
      this.nameNode.style.display = 'none';
      this.infoNode.style.display = 'none';
      this.removeImage();
      if (this.fileInputNode) {
        this.fileInputValue = '';
        this.fileInputNode.value = '';
        epages.event.fire(this.fileInputNode, 'change');
      }
      if(this.deleteNode) {
        dojo.addClass(this.deleteNode.domNode, 'HideElement');
      }
      dojo.publish(this.id + '/delete');
    },

    removeImage: function() {
      // summary:
      //    set empty image (hide the current image)
      if(this.slidesWidget) {
        this.slidesWidget.addImage({image: epages.vars.IconsRoot + "/general_img_transparentpixel.gif"}, true);
      }
    },


    _openMediaGallery: function(/*Event*/evt) {
      var MediaGallery = $$('MediaGallery');
      // set onApply function
      var me = this;
      var onApply = function(selectedElements) {
        if(selectedElements.length>0) {
          me._setFileForProduct(selectedElements);
        }
        };
      if(MediaGallery === undefined) {
        MediaGallery = new epages.cartridges.de_epages.mediagallery.widget.Mediagallery({
          id:               'MediaGallery',
          siteId:           this.siteId,
          url:              this.url,
          applyButtonLabel: this.translate('Apply'),
          multiSelect:      this.multiSelect,
          onApply:          onApply
        });
        document.getElementsByTagName("body")[0].appendChild(MediaGallery.domNode);
      } else {
        MediaGallery.multiSelect = this.multiSelect;
        MediaGallery.setOnApply(onApply);
      }
      MediaGallery.show();
    },

    /**
     * events & messages
     */

    onUploadProductImage: function(response) {
      if(this.slidesWidget && response.uploadedFile) {
        var slidesFile;
        slidesFile = response.uploadedFile;

        if(this.filePath && slidesFile) {
          var responseFullFilename = this.filePath + slidesFile;
          this.slidesWidget.addImage({image: responseFullFilename}, true);
          if(this.nameNode) {
            this.nameNode.innerHTML = slidesFile;
          }
          if(this.deleteNode) {
            this.deleteNode.fileName = slidesFile;
            this.deleteNode.filePath = this.filePath;
            this.deleteNode.domNode.style.display = '';
            dojo.removeClass(this.deleteNode.domNode, 'HideElement');
          }
        }
      }
    },

    /**
     * private methods
     */
    _setFileForProduct: function(filesArray){
      dojo.publish("uimessage/startBusy", ["Toolproductimages", this.translate('CopyImageFromMediagallery')]);
      for( var i=0,iLength=filesArray.length ; i<iLength ; i++ ){
        if(this.setProductImages && filesArray[i].mimetype.search(/image/) == -1){
          dojo.publish("uimessage/stopBusy", ["Toolproductimages"]);
          //check if file is an image if setProductImages is activated
          dojo.publish("uimessage/show", [ this.translate('FileNoImage'), this.translate('SelectImage'), 'Dialog', {
              titleBar: this.translate('MediaGallery')+" &ndash; "+this.translate('Notification'),
              typeClass: 'Warning'
            }
          ]);
          return;
        }
        var json = new epages.io.Json;
        var tempParams = this.scaleParams.split('&');
        var scaleParams = {};
        for( var j=0,jLength=tempParams.length ; j<jLength ; j++ ){
          var el = tempParams[j].split('=');
          scaleParams[el[0]] = el[1];
        }
        var params = {
          'ChangeAction': 'MoveAndScaleImage',
          'ObjectID':   this.objectId,
          'File':  filesArray[i].path
        };
        if(this.setProductImages){
          params['SetFilesForProduct'] = true;
        }
        var result = json.loadSync(this.url,dojo.mixin(params,scaleParams));
      }
      dojo.publish("uimessage/stopBusy", ["Toolproductimages"]);
      if (epages.string.toBoolean(this.reloadAfterUpload)){
        var dialogArea = actualDialogArea ? "DialogArea=" + actualDialogArea : "";
        if(location.href.search(/DialogArea/) != -1){
          var newLocation = location.href;
          for( var i=0,iLength=epagesDialog.areaName.length ; i<iLength ; i++ ){
            var regEx = new RegExp('DialogArea='+epagesDialog.areaName[i]);
            newLocation = newLocation.replace(regEx,dialogArea);
          }
          location.href = newLocation;
        }
        else{
          if(dialogArea == ''){
            location.href = location.href;
          }
          else{
            location.href = location.href + '&'+dialogArea;
          }
        }
      }
    }
});

})(jQuery);

}

if(!dojo._hasResource['epages.validate.string']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.validate.string'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.validate.string $Revision: 1.4 $

*/
dojo.provide('epages.validate.string');

epages.validate.string.isXMLAttribute = function(attributeName) {
	if (attributeName == ''){
		return false;
	}

	// reference http://www.w3.org/TR/REC-xml/#NT-Name
	var XML_SYNTAX_BaseChar      = "[\u0041-\u005A\u0061-\u007A\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u00FF\u0100-\u0131\u0134-\u013E\u0141-\u0148\u014A-\u017E\u0180-\u01C3\u01CD-\u01F0\u01F4-\u01F5\u01FA-\u0217\u0250-\u02A8\u02BB-\u02C1\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03CE\u03D0-\u03D6\u03DA\u03DC\u03DE\u03E0\u03E2-\u03F3\u0401-\u040C\u040E-\u044F\u0451-\u045C\u045E-\u0481\u0490-\u04C4\u04C7-\u04C8\u04CB-\u04CC\u04D0-\u04EB\u04EE-\u04F5\u04F8-\u04F9\u0531-\u0556\u0559\u0561-\u0586\u05D0-\u05EA\u05F0-\u05F2\u0621-\u063A\u0641-\u064A\u0671-\u06B7\u06BA-\u06BE\u06C0-\u06CE\u06D0-\u06D3\u06D5\u06E5-\u06E6\u0905-\u0939\u093D\u0958-\u0961\u0985-\u098C\u098F-\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09DC-\u09DD\u09DF-\u09E1\u09F0-\u09F1\u0A05-\u0A0A\u0A0F-\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32-\u0A33\u0A35-\u0A36\u0A38-\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8B\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2-\u0AB3\u0AB5-\u0AB9\u0ABD\u0AE0\u0B05-\u0B0C\u0B0F-\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32-\u0B33\u0B36-\u0B39\u0B3D\u0B5C-\u0B5D\u0B5F-\u0B61\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99-\u0B9A\u0B9C\u0B9E-\u0B9F\u0BA3-\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB5\u0BB7-\u0BB9\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C33\u0C35-\u0C39\u0C60-\u0C61\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CDE\u0CE0-\u0CE1\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D28\u0D2A-\u0D39\u0D60-\u0D61\u0E01-\u0E2E\u0E30\u0E32-\u0E33\u0E40-\u0E45\u0E81-\u0E82\u0E84\u0E87-\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA-\u0EAB\u0EAD-\u0EAE\u0EB0\u0EB2-\u0EB3\u0EBD\u0EC0-\u0EC4\u0F40-\u0F47\u0F49-\u0F69\u10A0-\u10C5\u10D0-\u10F6\u1100\u1102-\u1103\u1105-\u1107\u1109\u110B-\u110C\u110E-\u1112\u113C\u113E\u1140\u114C\u114E\u1150\u1154-\u1155\u1159\u115F-\u1161\u1163\u1165\u1167\u1169\u116D-\u116E\u1172-\u1173\u1175\u119E\u11A8\u11AB\u11AE-\u11AF\u11B7-\u11B8\u11BA\u11BC-\u11C2\u11EB\u11F0\u11F9\u1E00-\u1E9B\u1EA0-\u1EF9\u1F00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2126\u212A-\u212B\u212E\u2180-\u2182\u3041-\u3094\u30A1-\u30FA\u3105-\u312C\uAC00-\uD7A3]";
	var XML_SYNTAX_Ideographic   = "[\u4E00-\u9FA5\u3007\u3021-\u3029]";
	var XML_SYNTAX_CombiningChar = "[\u0300-\u0345\u0360-\u0361\u0483-\u0486\u0591-\u05A1\u05A3-\u05B9\u05BB-\u05BD\u05BF\u05C1-\u05C2\u05C4\u064B-\u0652\u0670\u06D6-\u06DC\u06DD-\u06DF\u06E0-\u06E4\u06E7-\u06E8\u06EA-\u06ED\u0901-\u0903\u093C\u093E-\u094C\u094D\u0951-\u0954\u0962-\u0963\u0981-\u0983\u09BC\u09BE\u09BF\u09C0-\u09C4\u09C7-\u09C8\u09CB-\u09CD\u09D7\u09E2-\u09E3\u0A02\u0A3C\u0A3E\u0A3F\u0A40-\u0A42\u0A47-\u0A48\u0A4B-\u0A4D\u0A70-\u0A71\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0B01-\u0B03\u0B3C\u0B3E-\u0B43\u0B47-\u0B48\u0B4B-\u0B4D\u0B56-\u0B57\u0B82-\u0B83\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0C01-\u0C03\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55-\u0C56\u0C82-\u0C83\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5-\u0CD6\u0D02-\u0D03\u0D3E-\u0D43\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0EB1\u0EB4-\u0EB9\u0EBB-\u0EBC\u0EC8-\u0ECD\u0F18-\u0F19\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86-\u0F8B\u0F90-\u0F95\u0F97\u0F99-\u0FAD\u0FB1-\u0FB7\u0FB9\u20D0-\u20DC\u20E1\u302A-\u302F\u3099\u309A]";
	var XML_SYNTAX_Digit         = "[\u0030-\u0039\u0660-\u0669\u06F0-\u06F9\u0966-\u096F\u09E6-\u09EF\u0A66-\u0A6F\u0AE6-\u0AEF\u0B66-\u0B6F\u0BE7-\u0BEF\u0C66-\u0C6F\u0CE6-\u0CEF\u0D66-\u0D6F\u0E50-\u0E59\u0ED0-\u0ED9\u0F20-\u0F29]";
	var XML_SYNTAX_Extender      = "[\u00B7\u02D0\u02D1\u0387\u0640\u0E46\u0EC6\u3005\u3031-\u3035\u309D-\u309E\u30FC-\u30FE]";
	var XML_SYNTAX_Letter        = XML_SYNTAX_BaseChar + "|" + XML_SYNTAX_Ideographic;
	var XML_SYNTAX_NameChar      = XML_SYNTAX_Letter + "|" + XML_SYNTAX_Digit + "|[-._:]|" + XML_SYNTAX_CombiningChar + "|" + XML_SYNTAX_Extender;
	var XML_SYNTAX_Name          = "^(" + XML_SYNTAX_Letter + "|[_:])" + "(" + XML_SYNTAX_NameChar + ")*$";

	return attributeName.match( new RegExp( XML_SYNTAX_Name ) ) ? true : false;
};
epages.validate.string.filterInvalidChars = function(/*string*/ insertString){
	// summary: removes invalid chars from given string
   // description: function removes invalid chars or combination of chars from given string
   // remove all backslashes can cause errors on the server
   // example:
   //    var result = epages.validate.string.filterInvalidChars('Affe/\Ente');
   // returns:  Affe/Ente
	var regExpString = /%5C/gi;
	insertString = encodeURIComponent(insertString);
	var returnString = insertString.replace(regExpString,'');
	returnString = decodeURIComponent(returnString);
	return returnString;
};

}

if(!dojo._hasResource["epages.cartridges.de_epages.product.widget.VariationAttributeList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.widget.VariationAttributeList"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.product.widget.VariationAttributeList $Revision: 1.11.86.1 $

*/
dojo.provide("epages.cartridges.de_epages.product.widget.VariationAttributeList");







dojo.declare("epages.cartridges.de_epages.product.widget.VariationAttributeList",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		allowDuplicates:      "false",
		attributeAlias:       "",
		autoEmptyRow:         "true",
		emptyInputNamePrefix: "EmptyValue",
		isLocalized:          "true",
		isNew:                "false",
		isUsed:               "false",
		newInputNamePrefix:   "VariationAttributeValues",
		maxAttributeValues:   10,
		nextButtonId:         '',

		/**
		 * private properties
		 */
		_attributeCounter: '', 				// String - remember counter to set input names
		_oldValues:        undefined, // String[] - array of old values
		_widgetsOfClass:   [], 				// dijit._Widget[] - list of widgets (used by all widgets of this class)
		_existingAttributes: [], 			// String[] - list of all existing attribute alias of product type

		/**
		 * widget properties
		 */
		templateString:"<div class=\"VariationAttributeList\">\n\n<h2><span dojoAttachPoint=\"headlineNode\">X</span>. {Attribute}</h2>\n\n<!-- ErrorMessages -->\n<div class=\"HideElement\">\n  <div dojoAttachPoint=\"DuplicateAttributeValueAlias\">\n    <p>{DuplicateAttributeValueAlias}</p>\n  </div>\n  <div dojoAttachPoint=\"AttributeAliasNoXMLName\">\n    <p>{AttributeAliasNoXMLName}</p>\n  </div>\n  <div dojoAttachPoint=\"ProductAttributeExists\">\n    <p>{ProductAttributeExists}</p>\n  </div>\n  <div dojoAttachPoint=\"EmptyAttributeAlias\">\n    <p>{EmptyAttributeAlias}</p>\n  </div>\n</div>\n\n<!-- AttributeAlias, Localize Checkbox, DeleteAttributeLink -->\n<div class=\"TopSmallPadding BottomSmallPadding\" >\n  <div class=\"FloatLeft\">\n    <input type=\"text\" size=\"33\" maxlength=\"30\" disabled=\"disabled\" class=\"Disabled RightMargin\"\n           dojoAttachPoint=\"attributeAliasNode\"\n           name=\"VariationAttributeAliasX\"\n           value=\"${attributeAlias}\"\n           placeholder=\"{Example}: {Color}\" />\n    <input type=\"hidden\" dojoAttachPoint=\"attributeAliasHiddenNode\" name=\"VariationAttributeAliasX\" value=\"${attributeAlias}\" />\n    <input dojoAttachPoint=\"typePackageNode\" type=\"hidden\" name=\"TypePackageX\" value=\"\" />\n\n    <input dojotype=\"epages.widget.FormElement\"\n           dojoAttachPoint=\"localizableNode\"\n           type=\"text\" class=\"Checkbox AlignMiddle\"\n           value=\"1\"\n           disabled=\"disabled\"\n           id=\"Localizable_${id}\"\n    />\n    <label for=\"Localizable_${id}\">{MulitiLingualAttribute}</label>\n    <img src=\"${imagePath}/ico_s_bubblehelp.png\" alt=\"\" class=\"BubbleHelp\" />\n    <span class=\"ToolTip ep-js\" data-js=\".uiTooltip({})\">{BubblehelpMulitiLingualAttribute}</span>\n  </div>\n  <div class=\"FloatRight\">\n    <span class=\"CommandLinkSmall LeftMargin HideElement\"\n          dojoAttachPoint=\"deleteAttributeNode\"><span>\n      <i class=\"RightMargin Sprite ico_s_delete\"></i>{DeleteAttribute}\n    </span></span>\n  </div>\n  <div class=\"ClearBoth\"></div>\n</div>\n<!-- use Attribute as Variation Attribute  -->\n<div class=\"BottomSmallPadding\" dojoAttachPoint=\"isUsedBlockNode\">\n  <p class=\"NoMargin\">{AttributeIsDefinedButNotUsed}</p>\n  <input type=\"hidden\" dojoAttachPoint=\"isUsedValueNode\" name=\"UseAttributeX\" value=\"1\" />\n  <input type=\"text\" checked=\"checked\" class=\"Checkbox AlignMiddle\"\n         dojoType=\"epages.widget.FormElement\"\n         dojoAttachPoint=\"isUsedFormNode\"\n         id=\"DoUseAttribute_${id}\"\n   />\n  <label for=\"DoUseAttribute_${id}\" >{UseThisAttribute}</label>\n</div>\n<!-- attribute value table -->\n<table class=\"ContentList BottomMargin\">\n  <thead><tr><td>{Value}</td><td class=\"ExtraSlimColumn\"></td></tr></thead>\n  <tfoot><tr><td colspan=\"2\"></td></tr></tfoot>\n  <tbody dojoAttachPoint=\"tableBodyNode\">\n    <tr class=\"HideElement\"><td>RowTemplate</td><td>&nbsp;</td></tr>\n    <tr class=\"HideElement\">\n      <td><input class=\"jsInput TextSlim\" type=\"text\" name=\"\" value=\"\" placeholder=\"{Example}: {Red}\"></td>\n      <td class=\"AlignCenter\"><i class=\"jsAnchor LinkImage HideElement Sprite ico_s_delete\" title=\"{DeleteAttributeValue}\"></i></td>\n    </tr>\n  </tbody>\n</table>\n\n<div>\n",
		translationName: dojo.moduleUrl('epages.cartridges.de_epages.product.widget', 'templates/translation'),
		imagePath:       epages.themeUrl('images'),
		widgetsInTemplate : true,

		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);
			this.autoEmptyRow=epages.string.toBoolean(this.autoEmptyRow);
			this.allowDuplicates=epages.string.toBoolean(this.allowDuplicates);
			this.isLocalized=epages.string.toBoolean(this.isLocalized);
			this.isNew=epages.string.toBoolean(this.isNew);
			this.isUsed=epages.string.toBoolean(this.isUsed);
			this._oldValues = [];
			this._attributeCounter = this._widgetsOfClass.length;
			this._widgetsOfClass.push(this);
		},

		setAttributeCounter: function (counter) {
			this.typePackageNode.name="TypePackage"+counter;
			this.attributeAliasNode.name="VariationAttributeAlias"+counter;
			this.attributeAliasHiddenNode.name="VariationAttributeAlias"+counter;
			this.isUsedValueNode.name="UseAttribute"+counter;
			this.headlineNode.innerHTML="" + (Number(counter) + 1);
			this._attributeCounter = counter;
			this.reorgInputs();
		},

		startup: function() {
			this.inherited("startup", arguments);
			if (this.autoEmptyRow) {
				this.addNewRow();
			}
			this.setAttributeCounter(this._attributeCounter);
			// set initial values for localized
			this.localizableNode.attr('checked',this.isLocalized);
			this._onLocalizedClick();
			if (this.isNew) {
				this.attributeAliasHiddenNode.parentNode.removeChild(this.attributeAliasHiddenNode);

				// activate attribute alias
				this.connect(this.attributeAliasNode,'onchange', '_onChangeAttributeAlias');
				this.connect(this.attributeAliasNode,'onkeyup', '_onChangeAttributeAlias');
				this.connect(this.attributeAliasNode,'onclick', '_onChangeAttributeAlias');
				this.attributeAliasNode.disabled=false;
				dojo.removeClass(this.attributeAliasNode, 'Disabled');

				// activate localized checkbox
				this.connect(this.localizableNode.elementNode, 'onclick', '_onLocalizedClick');
        this.localizableNode.attr('disabled',false);

				// activate delete attribute link
				this.connect(this.deleteAttributeNode, 'onclick', '_onClickDeleteAttribute');
				dojo.removeClass(this.deleteAttributeNode,'HideElement');
			}
			// active use variation attribute checkout
			if (this.isUsed || this.isNew) {
				dojo.addClass(this.isUsedBlockNode,'HideElement');
				this.isUsedFormNode.attr('disabled',true);
			} else {
				this.connect(this.isUsedFormNode.elementNode, 'onclick', '_onIsUsedClick');
			}
		},

		rows : function () {
			return dojo.filter(this.tableBodyNode.childNodes,function (el) { return el.nodeName == 'TR'; });
		},

		_setAlternateClass: function () {
			var alternate = true;
			dojo.forEach(this.rows(), function (el) {
				alternate= !alternate;
				if (alternate) {
					dojo.addClass(el,'alternate');
				} else {
					dojo.removeClass(el,'alternate');
				}
			});
		},

		getInput: function (row) {
			var inputs = dojo.query('.jsInput', row);
			return inputs.length > 0 ? inputs[0] : undefined;
		},

		getInputs: function () {
			var inputs = [];
			dojo.forEach(this.rows(), function (row) {
				var r = dojo.query('.jsInput', row);
				if (r.length > 0){
					inputs.push(r[0]);
				}
			});
			return inputs;
		},

		getAnchor: function (row) {
			return dojo.query('.jsAnchor', row)[0];
		},

		addValue: function (/*String*/ alias) {
			// get existing rows and template
			var rows = this.rows();
			var template = rows[rows.length - 2];
			// create new row
			var newRow = template.cloneNode(true);
			var cells = dojo.filter(newRow.childNodes,function (el) { return el.nodeName == 'TD'; });
			cells[0].innerHTML = alias;
			dojo.removeClass(newRow, 'HideElement');
			// insert before template and new elements
			this.tableBodyNode.insertBefore(newRow, rows[this._oldValues.length]);
			// add to internal values
			this._oldValues.push(alias);
			this._setAlternateClass();
		},

		addNewRow: function () {
			if (this.getInputs().length + this._oldValues.length > this.maxAttributeValues){
				return;
			}

			// get existing rows and template
			var rows = this.rows();
			var template = rows[rows.length - 1];
			// create new row
			var row = template.cloneNode(true);
			var input  = this.getInput(row);
			input.name = this.emptyInputNamePrefix;
			var anchor = this.getAnchor(row);

			this.connect(anchor,'onclick', function () {
				input.value='';
				this.onChangeInput(input, anchor);
				this.onDeleteInput(row);
			});
			var f = function () { this.onChangeInput(input, anchor); };
			this.connect(input,'onchange', f);
			this.connect(input,'onkeyup',  f);
			this.connect(input,'onclick',  f);
			this.connect(input,'onblur', function () {
				if (this.isInputEmpty(input)) {
					this.onDeleteInput(row);
				}
			});
			dojo.removeClass(row, 'HideElement');
			// insert before templates
			this.tableBodyNode.insertBefore(row, rows[rows.length - 2]);
			this._setAlternateClass();
		},

		isInputEmpty: function (input) {
			return input.value == '';
		},

		_changeErrorMessage: function (isValid, errorNode, inputNode) {
			if(!isValid) {
				var absolutePositionY = ($E(inputNode).getAbsolutePosition(dojo.body()).y + inputNode.offsetHeight);
				dojo.publish("uimessage/show", ["", errorNode.innerHTML, "Bubble", {
					typeClass: "Warning",
					sizeClass: "Small",
					x: $E(inputNode).getAbsolutePosition(dojo.body()).x,
					y: absolutePositionY
				}]);
			} else {
				dojo.publish("uimessage/hide", []);
			}
			return isValid;
		},

		onChangeInput: function (input, anchor) {
			if (!this.isInputEmpty(input) && dojo.hasClass(anchor,'HideElement')) {
				dojo.removeClass(anchor,'HideElement');
			}
			if (!this.allowDuplicates) {
				if (this.isInputEmpty(input)) {
					dojo.removeClass(input, 'DialogError');
				} else {
					//check if value only consists of whitespace chars
					var whitespaceCleared = input.value.replace(/\s/g,'');
					if(whitespaceCleared.length == 0){
						dojo.addClass(input, 'DialogError');
					}
					else{
						dojo.removeClass(input, 'DialogError');
						var value = input.value;
						var lcValue = value.toLowerCase();
						var oldValues = dojo.filter(this._oldValues, function (el) { return el.toLowerCase() == lcValue; });
						if (oldValues.length) {
							dojo.addClass(input, 'DialogError');
						} else {
							var inputs = dojo.filter(this.getInputs(), function (el) { return input != el && lcValue == el.value.toLowerCase(); });
							this._changeErrorMessage(inputs.length == 0, this.DuplicateAttributeValueAlias, input);
							if(inputs.length != 0) {
								dojo.addClass(input, 'DialogError');
							}
						}
					}
				}
			}
			this.reorgInputs();
		},

		onDeleteInput: function (row) {
			row.parentNode.removeChild(row);
			this.reorgInputs();
		},

		reorgInputs: function () {
			var countEmptyRows = 0;
			var rows = this.rows();
			dojo.forEach(rows, function (row) {
				if (!dojo.hasClass(row,'HideElement')) {
					var input = this.getInput(row);
					if (input === undefined){
						return;
					}
					if (this.isInputEmpty(input)) {
						countEmptyRows++;
					} else {
						input.name = this.newInputNamePrefix + this._attributeCounter;
					}
				}
			}, this);
			if (this.autoEmptyRow && countEmptyRows == 0){
				this.addNewRow();
			}
			this._setAlternateClass();
			//need little timeout to set existing rows correct
			window.setTimeout(dojo.hitch(this,function(){this.enableNextButton();}),1);
		},

		_onLocalizedClick: function () {
			this.isLocalized  = this.localizableNode.elementNode.checked;
			this.typePackageNode.value= (this.isLocalized ? "PreDefLocalizedString" : "PreDefString");
		},

		_onIsUsedClick: function () {
			if (this.isUsedFormNode.elementNode.checked) {
				// hide text in information element
				jq(this.isUsedFormNode.elementNode).closest('div').children('p:first').slideUp(500);
				dojo.removeClass(this.tableBodyNode.parentNode,'HideElement');
				this.isUsedValueNode.value = "1";
				var isAllreadyInside = false;
				for( var i=0,iLength=this._widgetsOfClass.length ; i<iLength ; i++ ){
					if(this._widgetsOfClass[i] == this){
						isAllreadyInside = true;
					}
				}
				if(!isAllreadyInside){
					$A(this._widgetsOfClass).push(this);
				}
			} else {
				// show text in information element
				jq(this.isUsedFormNode.elementNode).closest('div').children('p:first').slideDown(500);
				dojo.addClass(this.tableBodyNode.parentNode,'HideElement');
				this.isUsedValueNode.value = "0";
			}
			this._checkNextButton();
		},

		_checkNextButton: function(){
			var allWidgets = this._widgetsOfClass;
			var disableButton = true;
			for( var i=0,iLength=allWidgets.length ; i<iLength ; i++ ){
				var widget = allWidgets[i];
				if(widget && widget.isUsedFormNode && widget.isUsedFormNode.elementNode && widget.isUsedFormNode.elementNode.checked){
					disableButton = false;
				}
			}
			var b = $$(this.nextButtonId);
			if(disableButton){
				if (b === undefined){
					$(this.nextButtonId).disabled="disabled";
				}
				else{
					b.disable();
				}
			}
			else{
				if (b === undefined){
					$(this.nextButtonId).disabled="";
				}
				else{
					b.enable();
				}
			}
		},

		_onChangeAttributeAlias: function () {
			var inputNode = this.attributeAliasNode;
			var value = inputNode.value;
			if (value == this.attributeAlias) {
				if (dojo.hasClass(inputNode,'DialogError')) {
					dojo.removeClass(inputNode,'DialogError');
					dojo.publish("uimessage/hide", []);
				}
				return;
			}
			// test if alias is empty
			var isOk = true;
			if (!this._changeErrorMessage(!this.isInputEmpty(inputNode), this.EmptyAttributeAlias, inputNode)) {
				isOk = false;
				dojo.addClass(inputNode,'DialogError');
			}
			// test if xml complaint
			if (isOk) {
				if(!this._changeErrorMessage(epages.validate.string.isXMLAttribute(value), this.AttributeAliasNoXMLName, inputNode)) {
					isOk = false;
				}
			}
			// test duplicate alias
			var lcValue = value.toLowerCase();
			if (isOk) {
				var aliases = dojo.filter(this._widgetsOfClass, function (el) { return el.attributeAlias.toLowerCase() == lcValue; });
				if (!this._changeErrorMessage(aliases.length == 0, this.ProductAttributeExists, inputNode)) {
					isOk = false;
					dojo.addClass(inputNode,'DialogError');
				}
			}
			if (isOk) {
				var aliases = dojo.filter(this._existingAttributes, function (el) { return el.toLowerCase() == lcValue; });
				if (!this._changeErrorMessage(aliases.length == 0, this.ProductAttributeExists, inputNode)) {
					isOk = false;
					dojo.addClass(inputNode,'DialogError');
				}
			}
			if (isOk) {
				this.attributeAlias = value;
			}
			this.enableNextButton();
		},

		_onClickDeleteAttribute: function () {
			// remove from list
			var allWidgets = this._widgetsOfClass;
			epages.cartridges.de_epages.product.widget.VariationAttributeList.prototype._widgetsOfClass = [];
			dojo.forEach(allWidgets, function (el) {
				if(el == this){
					return;
				}
				el.setAttributeCounter(this._widgetsOfClass.length);
				this._widgetsOfClass.push(el);
			}, this);
			this.enableNextButton();
			dojo.publish(this.id + '/onClickDeleteAttribute', [this]);
		},

		isValid: function () {
			//summary: check if current Attribute is valid
			//description: check if alias of attribute is defined, if values are set
			//and if there are no DialogErrors inside the inputs
			if(this.getInputs().length == 2 && this._oldValues.length == 0){
				return false; // Boolean
			}
			if (this.attributeAlias == ''){
				return false;
			}
			if (dojo.hasClass(this.attributeAliasNode,'DialogError')){
				return false;
			}
			var invalidInputs = dojo.filter(this.getInputs(), function (el) { return dojo.hasClass(el,'DialogError'); });
			if (invalidInputs.length){
				return false;
			}
			return true; // Boolean
		},

		enableNextButton: function() {
		// summary: send message to enable next button (if validation is ok)
			dojo.publish("step1/checkNextButton", []);
		},

		useAttribute: function () {
			return this.isUsed || this.isUsedFormNode.elementNode.checked;
		},

		getValues: function () {
			var values = [];
			for (var i = 0, length = this._oldValues.length; i < length; i++){
				values.push(this._oldValues[i]);
			}
			dojo.forEach(this.getInputs(), function (input) {
				if (!this.isInputEmpty(input)){
					values.push(input.value);
				}
			}, this);
			return values;
		},

		hasNewAttributes: function () {
			var allWidgets = epages.cartridges.de_epages.product.widget.VariationAttributeList.prototype._widgetsOfClass;
			if (allWidgets.length == 0){
				return false;
			}
			var newWidgets = dojo.filter(allWidgets, function (el) { return el.isNew; });
			return newWidgets.length > 0;
		},

		getAttributeCounter: function () {
			return this._attributeCounter;
		}

});

}

if(!dojo._hasResource["epages.cartridges.de_epages.product.widget.VariationProductList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.widget.VariationProductList"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.product.widget.VariationProductList $Revision: 1.8 $

*/
dojo.provide("epages.cartridges.de_epages.product.widget.VariationProductList");




dojo.declare("epages.cartridges.de_epages.product.widget.VariationProductList",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		productAlias:        "",
		maxListedProducts:   400,
		maxSelectedProducts: 200, // feature ProductMaxSubProducts
		nextButtonId:        "",

		/**
		 * private properties
		 */
		_attributeAliases: undefined,
		_existingProducts: undefined,
		_newProducts:      undefined,
		_existingProductsKey: undefined,
		_newProductsKey:      undefined,
		_currentTable:     undefined,
		_counterExistingProducts: 0,
		_counterNewProductAlias: 0,
		_maxExistingProductReached: false,
		_maxNewProductReached: false,
		_inputs: undefined,

		/**
		 * widget properties
		 */
		templateString:"<div class=\"VariationProductList\">\n\n<!-- ErrorMessages -->\n<div>\n  <div class=\"DialogMessage MessageInfo HideElement\"  dojoAttachPoint=\"ErrorNewProductsNode\">\n    <h3>{Notification}</h3>\n    <p class=\"HideElement\" dojoAttachPoint=\"ErrorNotAllNewProductsInListNode\">{NotAllNewProductsInList}</p>\n    <p class=\"HideElement\" dojoAttachPoint=\"ErrorMoreNewProductsAsPossibleNode\">{MoreNewProductsAsPossible}</p>\n  </div>\n  <div class=\"DialogMessage MessageInfo HideElement\" dojoAttachPoint=\"ErrorMaxSubProductsReachedNode\">\n    <h3>{Notification}</h3>\n    <p>{MaxSubProductsReached}</p>\n  </div>\n  <div class=\"DialogMessage MessageWarning HideElement\" dojoAttachPoint=\"ErrorDuplicateProductAliasNode\">\n    <h3>{InputError}</h3>\n    <p>{DuplicateProductAlias}</p>\n  </div>\n</div>\n\n<!-- product table -->\n<div dojoAttachPoint=\"targetNode\">\n</div>\n\n<div>\n",
		translationName: dojo.moduleUrl('epages.cartridges.de_epages.product.widget', 'templates/translation'),
		imagePath:       epages.themeUrl('images'),

		templateTable: ['<table class="ContentList BottomMargin">'+
											'<thead><tr><td class="Checkbox"><input checked="checked" class="Checkbox" dojotype="epages.widget.FormElement" name="selector" value="checkbox" onclick="OnCheckAll(this.form, \'ListItem\', this.checked);" type="text" /></td>', // 0
											'<td>','</td>', // 1 + 2
											'</tr></thead>'+
											'<tfoot><tr><td colspan="','"></tr></tfoot><tbody>','</tbody>'+ // 3+4+5
										'</table>' // 5
									 ],
		templateOldRow: ['<tr','>'+
									'<td class="Checkbox"><input disabled="disabled" class="Checked Checkbox Disabled" type="text" checked="checked" name="ListItem" value="" /></td>'+
									'<td class="MediumColumn NoWrap"><img title="" alt="" src="'+epages.vars.IconsRoot+'/object_ico_s_product.png" />','</td>',
									'<td>','</td>',
									'</tr>'
									],
		templateNewRow: ['<tr','>'+
									'<td class="Checkbox"><input type="text" checked="checked" name="ListItem" value="','" class="Checked Checkbox Disabled" dojotype="epages.widget.FormElement" /></td>' +
									'<td class="MediumColumn NoWrap"><img title="" alt="" src="'+epages.vars.IconsRoot+'/object_ico_s_product.png" /><input class="jsInput" type="text" name="VariationAlias','" value="','" /></td>',
									'<td>','<input type="hidden" name="NewVariationAttributeValues','" value="','" /></td>',
									'</tr>'
									],

		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);
			this.maxListedProducts   = Number(this.maxListedProducts);
			this.maxSelectedProducts = Number(this.maxSelectedProducts);
			this._attributeAliases = [];
			this._existingProducts    = {};
			this._existingProductsKey = {};
			this._newProducts    = {};
			this._newProductsKey = {};
		},

		postCreate: function() {
			this.inherited("postCreate", arguments);
			var node = this.targetNode;
			this.connect(node,'onchange', '_onListEvent');
			this.connect(node,'onkeyup', '_onListEvent');
			this.connect(node,'onclick', '_onListEvent');
		},

		addAttribute: function (alias) {
			this._attributeAliases.push(alias);
		},

		buildKey: function(data) {
			return dojo.map(this._attributeAliases, function (el) { return data[el]; }).join("\n");
		},

		addExistingProduct: function (alias, productData) {
			this._existingProducts[alias] = productData;
			this._existingProductsKey[this.buildKey(productData)] = alias;
			this._counterExistingProducts++;
			if (this._counterExistingProducts >= this.maxSelectedProducts) {
				this._maxExistingProductReached = true;
				dojo.removeClass(this.ErrorMaxSubProductsReachedNode,'HideElement');
				return;
			}
		},

		buildNewAlias: function () {
			this._counterNewProductAlias++;
			var s = this._counterNewProductAlias.toString();
			if(s.length==1){
				s="000"+s;
			}
			if(s.length==2){
				s="00"+s;
			}
			if(s.length==3){
				s="0"+s;
			}
			return this.productAlias+'-'+s;
		},

		addNewProduct: function (productData) {
			if(this._maxExistingProductReached){
				return true;
			}
			if(this._counterNewProductAlias >= this.maxListedProducts) {
				if (this._maxNewProductReached){
					return true;
				}
				this._maxNewProductReached = true;
				dojo.removeClass(this.ErrorNewProductsNode,'HideElement');
				dojo.removeClass(this.ErrorNotAllNewProductsInListNode,'HideElement');
				return true;
			}
			var key = this.buildKey(productData);
			if(this._existingProductsKey[key] || this._newProductsKey[key]) {
				return false;
			}
			// find new alias
			var alias = this.buildNewAlias();
			while (this._newProducts[alias] !== undefined || this._existingProducts[alias] !== undefined) {
				alias = this.buildNewAlias();
			}

			// register new product
			this._existingProductsKey[key] = alias;
			this._newProducts[alias] = productData;
			return false;
		},

		showTable: function () {
			// show error MoreNewProductsAsPossible
			if(this._counterNewProductAlias > this.maxSelectedProducts) {
				dojo.removeClass(this.ErrorNewProductsNode,'HideElement');
				dojo.removeClass(this.ErrorMoreNewProductsAsPossibleNode,'HideElement');
			}
			// **** build table ****
			var rows = [];
			var template = this.templateTable;
			rows.push(template[0]);

			// build header
			rows.push(template[1]+this.translate('SKU')+template[2]);
			dojo.forEach(this._attributeAliases, function (el) {
				rows.push(template[1]+el+template[2]);
			}, this);

			// colspan footer
			rows.push(template[3]+(this._attributeAliases.length + 2)+template[4]);

			// build existing products
			template=this.templateOldRow;
			var isAlternate = true;
			for (var alias in this._existingProducts) {
				isAlternate = !isAlternate;
				data = this._existingProducts[alias];
				rows.push(template[0] + (isAlternate ? ' class="alternate" ' : '') + template[1]+alias+template[2]);
				dojo.forEach(this._attributeAliases, function (el) {
					if(data[el]){
						rows.push(template[3]+ epages.string.escapeXml(data[el]) + template[4]);
					}
				});
				rows.push(template[5]);
			}
			// build new products
			var counter = 0;
			template=this.templateNewRow;
			for(var alias in this._newProducts) {
				isAlternate = !isAlternate;
				data = this._newProducts[alias];
				rows.push(template[0] + (isAlternate ? ' class="alternate" ' : '') + template[1]+counter+template[2]+counter+template[3]+alias+template[4]);
				dojo.forEach(this._attributeAliases, function (el) {
					if(data[el]){
						rows.push(template[5]+epages.string.escapeXml(data[el])+template[6]+counter+template[7]+epages.string.escapeXml(data[el])+template[8]);
					}
				});
				rows.push(template[9]);
				counter++;
			}
			rows.push(this.templateTable[5]);
			this.targetNode.innerHTML = rows.join("\n");
			dojo.parser.parse(this.targetNode);
			// clear temp new products, because aliases can be changed, so they can not used longer
			this._existingProductsKey = {};
			this._newProducts = {};
		},

		checkInputAlias: function (input) {
			var v = input.value.toLowerCase();
			var nodes = dojo.filter(dojo.query(".jsInput", this.targetNode), function (el) {
				var checkBoxNode = dojo.query('input[name="ListItem"]',el.parentNode.parentNode)[0];
				if(checkBoxNode && !checkBoxNode.checked){
					return false;
				}
				else{
					return el.value.toLowerCase() == v;
				}
			});
			if (this._existingProducts[v] || nodes.length > 1) {
				if (!dojo.hasClass(input,'DialogError')) {
					dojo.addClass(input,'DialogError');
					this.enableNextButton();
					dojo.removeClass(this.ErrorDuplicateProductAliasNode,'HideElement');
				}
			} else {
				if (dojo.hasClass(input,'DialogError')) {
					dojo.removeClass(input,'DialogError');
					dojo.forEach(dojo.query(".DialogError", this.targetNode), this.checkInputAlias, this);
					if (this._areInputsValid()) {
						dojo.addClass(this.ErrorDuplicateProductAliasNode,'HideElement');
						this.enableNextButton();
					}
				}
			}
		},

		_onListEvent: function (evt) {
			if (evt.target.nodeName != 'INPUT'){
				return;
			}
			var input = evt.target;
			if (input.type == 'text') {
				var checkBoxNode = dojo.query('input[name="ListItem"]',input.parentNode.parentNode)[0];
				if(checkBoxNode && checkBoxNode.checked){
					this.checkInputAlias(input);
				}
			}
			else if(input.type =='checkbox' && input.checked){
				var aliasInput = document.getElementsByName('VariationAlias' + input.value)[0];
				if(aliasInput){
					this.checkInputAlias(aliasInput);
				}
			}
		},

		_areInputsValid: function () {
			var nodes = dojo.query(".DialogError", this.targetNode);
			return nodes.length == 0;
		},

		_areCheckboxesValid: function () {
			return true;
		},

		enableNextButton: function () {
			if (this.nextButtonId == ''){
				return;
			}
			var valid = this._areInputsValid() && this._areCheckboxesValid();

			var b = $$(this.nextButtonId);
			if (b === undefined){
				$(this.nextButtonId).disabled=!valid;
			}else if (valid){
				b.enable();
			}else{
				b.disable();
			}
		},

		resetAttributesList: function () {
			this._attributeAliases = [];
		},

		resetExistingProductKeys: function () {
			this._existingProductsKey = {};
			for (var alias in this._existingProducts) {
				var productData = this._existingProducts[alias];
				this._existingProductsKey[this.buildKey(productData)] = alias;
			}
		},

		resetNewProductList: function () {
			this._counterNewProductAlias = 0;
			this.resetExistingProductKeys();
			this._newProducts = {};
			this._newProductsKey = {};
		},

		createNewProducts: function (attributeWidgets, data) {
			var widgets = [];
			for (var i = 0, length = attributeWidgets.length; i < length; i++){
				if(attributeWidgets[i].useAttribute()){
					widgets.push(attributeWidgets[i]);
				}
			}
			var widget = widgets.shift();
			var values = widget.getValues();
			if (widget.useAttribute() && values.length) {
				var alias = widget.attributeAlias;
				var abort = false;
				dojo.forEach(values, function (value) {
					if (abort){
						return;
					}
					data[alias] = value;
					if (widgets.length) {
						abort = this.createNewProducts(widgets, data);
					} else {
						var copy = {};
						for (var key in data){
							copy[key] = data[key];
						}
						abort = this.addNewProduct(copy);
					}
				}, this);
				return abort;
			}
			if (widgets.length){
				return this.createNewProducts(widgets, data);
			}
			return this.addNewProduct(data);
		},

		buildTable: function (widgets) {
			if (widgets === undefined) {
				widgets = epages.cartridges.de_epages.product.widget.VariationAttributeList.prototype._widgetsOfClass;
			}
			this.resetAttributesList();
			dojo.forEach(widgets, function (el) {
				if(el.useAttribute()){
					this.addAttribute(el.attributeAlias);
				}
			}, this);
			this.resetNewProductList();
			this.createNewProducts(widgets, {});
		},

		setOnExistingProducts: function (alias, value) {
			for (var key in this._existingProducts) {
				var data = this._existingProducts[key];
				data[alias]=value;
			}
		},

		getCountExistingProducts: function () {
			return this._counterExistingProducts;
		}
});

}

if(!dojo._hasResource["epages.cartridges.de_epages.product.widget.VariationDefaultList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.widget.VariationDefaultList"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.product.widget.VariationDefaultList $Revision: 1.7 $

*/
dojo.provide("epages.cartridges.de_epages.product.widget.VariationDefaultList");




dojo.declare("epages.cartridges.de_epages.product.widget.VariationDefaultList",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		attributeAlias: "",
		nextButtonId:   "",
		inputName:      "DefaultAttributeValue",

		/**
		 * private properties
		 */
		_values:         undefined,
		_widgetsOfClass: [], // list of widgets (used by all widgets of this class)

		/**
		 * widget properties
		 */
		templateString:"<div class=\"VariationDefaultList\">\n\n<!-- HeadLine -->\n<h3>{PredefinedValueForAttribute}: ${attributeAlias}</h3>\n\n<!-- product table -->\n<div dojoAttachPoint=\"targetNode\" class=\"TopMargin\">\n</div>\n\n<div>\n",
		translationName: dojo.moduleUrl('epages.cartridges.de_epages.product.widget', 'templates/translation'),

		templateTable: ['<table class="ContentList BottomMargin">'+
											'<tbody>','</tbody>'+ // 0+1
										'</table>' // 1
									],
		templateRow: ['<tr','>'+ // 0+1
									'<td class="Checkbox"><input class="jsInput ep-js" data-js="ep.uiInput()" type="radio" name="','" value="','" /></td><td>','</td>'+ // 1+2+3+4
									'</tr>' // 4
									],

		postMixInProperties: function() {
			this.inherited("postMixInProperties", arguments);
			this._values = [];
			this._widgetsOfClass.push(this);
		},

		postCreate: function() {
			this.inherited("postCreate", arguments);
			var node = this.targetNode;
			this.connect(node,'onclick', '_onListEvent');
		},

		addValue: function (value) {
			this._values.push(value);
		},

		showTable: function () {
			// **** build table ****
			var template = this.templateTable;
			var rows = [template[0]];

			// build tbody (rows)
			template=this.templateRow;
			var isAlternate = true;
			dojo.forEach(this._values, function (value) {
				isAlternate = !isAlternate;
				rows.push(template[0] + (isAlternate ? ' class="alternate" ' : '') + template[1]+this.inputName+template[2]+value+template[3]+value+template[4]);
			}, this);
			rows.push(this.templateTable[1]);
			this.targetNode.innerHTML = rows.join("\n");
			dojo.parser.parse(this.targetNode);
		},

		_onListEvent: function (evt) {
			if (evt.target.nodeName != 'INPUT'){
				return;
			}
			this.enableNextButton();
		},

		getInputs: function () {
			return dojo.filter(dojo.query('.jsInput', this.domNode), function (el) { return el.nodeName == 'INPUT'; });
		},

		isValid: function () {
			var radios = dojo.filter(this.getInputs(), function (el) { return el.checked; });
			return radios.length > 0;
		},

		getValue: function () {
			var radios = dojo.filter(this.getInputs(), function (el) { console.warn(el.checked); return el.checked; });
			if (radios.length == 0){
				return undefined;
			}
			return radios[0].value;
		},

		selectFirst: function () {
			var radios = this.getInputs();
			if (radios.length > 0){
				radios[0].checked = true;
			}
		},

		areAllValid: function () {
			var allWidgets = epages.cartridges.de_epages.product.widget.VariationDefaultList.prototype._widgetsOfClass;
			if (allWidgets.length == 0){
				return true;
			}
			var validWidgets = dojo.filter(allWidgets, function (el) { return el.isValid(); });
			return allWidgets.length == validWidgets.length;
		},

		enableNextButton: function () {
			if (this.nextButtonId == ''){
				return;
			}
			var valid = this.areAllValid();
			var b = $$(this.nextButtonId);

			if (b === undefined){
				$(this.nextButtonId).disabled=!valid;
			}else if (valid){
				b.enable();
			}else{
				b.disable();
			}
		}

});

}

if(!dojo._hasResource["epages.cartridges.de_epages.content.widget.TagEditor"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.content.widget.TagEditor"] = true;
dojo.provide("epages.cartridges.de_epages.content.widget.TagEditor");






parent.epages.cartridges.de_epages.content.widget.valueGrouped = {}; // collection of all selected tags in TagEditors grouped by a groupname

dojo.declare(
	"epages.cartridges.de_epages.content.widget._TagEditorMenu",
	dijit.form._ComboBoxMenu,
	{
		templateString: "<ul class='dijitReset dijitMenu dijitTagEditor' style='background-color:#FFF;' dojoAttachEvent='onmousedown:_onMouseDown,onmouseup:_onMouseUp,onmouseover:_onMouseOver,onmouseout:_onMouseOut' tabIndex='-1' style='overflow: \"auto\"; overflow-x: \"hidden\";'>"
			+"<li class='dijitMenuPreviousButton' dojoAttachPoint='previousButton' waiRole='option'></li>"
			+"<li class='dijitMenuNextButton' dojoAttachPoint='nextButton' waiRole='option'></li>"
		+"</ul>",
		itemClasses : "dijitReset",

		createOptions: function(results, dataObject, labelFunc){
			// summary:
			//		Fills in the items in the drop down list
			// results:
			//		Array of dojo.data items
			// dataObject:
			//		dojo.data store
			// labelFunc:
			//		Function to produce a label in the drop down list from a dojo.data item

			//this._dataObject=dataObject;
			//this._dataObject.onComplete=dojo.hitch(comboBox, comboBox._openResultList);
			// display "Previous . . ." button
			this.previousButton.style.display = (dataObject.start == 0) ? "none" : "";
			dojo.attr(this.previousButton, "id", this.id + "_prev");
			// create options using _createOption function defined by parent
			// ComboBox (or FilteringSelect) class
			// #2309:
			//		iterate over cache nondestructively
			dojo.forEach(results, function(item, i){
				var menuitem = this._createOption(item, labelFunc);
				menuitem.className = this.itemClasses;
				dojo.attr(menuitem, "id", this.id + i);
				this.domNode.insertBefore(menuitem, this.nextButton);
			}, this);
			// display "Next . . ." button
			var displayMore = false;
			//Try to determine if we should show 'more'...
			if(dataObject._maxOptions && dataObject._maxOptions != -1){
				if((dataObject.start + dataObject.count) < dataObject._maxOptions){
					displayMore = true;
				}else if((dataObject.start + dataObject.count) > (dataObject._maxOptions - 1)){
					//Weird return from a datastore, where a start + count > maxOptions
					// implies maxOptions isn't really valid and we have to go into faking it.
					//And more or less assume more if count == results.length
					if(dataObject.count == results.length){
						displayMore = true;
					}
				}
			}else if(dataObject.count == results.length){
				//Don't know the size, so we do the best we can based off count alone.
				//So, if we have an exact match to count, assume more.
				displayMore = true;
			}

			this.nextButton.style.display = displayMore ? "" : "none";
			dojo.attr(this.nextButton,"id", this.id + "_next");
			return this.domNode.childNodes;
		}
	}
);

dojo.declare(
	"epages.cartridges.de_epages.content.widget.TagEditor",
	dijit.form.ComboBox,
	{
		templateString: '',
		templateString:"<span id=\"widget_${id}\" style=\"border: 0px;\"\n\tdojoAttachEvent=\"\" dojoAttachPoint=\"comboNode\" waiRole=\"combobox\" tabIndex=\"-1\"\n\t><span style=\"overflow:hidden;\"\n\t\t><input name=\"${name}\" type=\"text\" autocomplete=\"off\" class='dijitReset'\n\t\t\tdojoAttachEvent=\"onkeypress:_onKeyPress,compositionend\"\n\t\t\tdojoAttachPoint=\"textbox,focusNode\" waiRole=\"textbox\" waiState=\"haspopup-true,autocomplete-list\"\n\t\t\tplaceholder=\"${placeholder}\"\n\t/></span\n>\n<span dojoAttachPoint=\"downArrowNode\" style=\"display:none\"></span>\n</span>\n",
		pageSize : 5, // old numberOfEntries

		/**
		 * public properties
		 */

		// this can be used to group multiple TagEditors on the same page
		// if a tag is added, then all TagEditors in the same group will
		// be updated with the new tag
		group:              "", // string - name of all tag inputs which share the same tags
		presetTags:      	"", // string - use this to preset Tags, seperate with ","
		value:              "", // string[]
		name:               "Tags", // string
		delimiter:			',', // string - tagseperator
		placeholder: '',

		description:        '', // string

		// hasDownArrow: [const] Boolean
		//		Set this textbox to have a down arrow button, to display the drop down list.
		//		Defaults to true.
		hasDownArrow: false,

		// searchDelay: Integer
		//		Delay in milliseconds between when user types something and we start
		//		searching based on that value
		searchDelay: 100,
		style: '',
		labelType: "html",

		storeType : "epages.cartridges.de_epages.content.widget._TagEditorStore",
		/**
		 * private properties
		 */

		_editAtLastEl  :    true, // is the user edition the last tag in the taglist
		_activeTagIndex:    null, // current working tag

		postMixInProperties: function() {

			this.store = {"dummy":"dummy"};
			this.inherited("postMixInProperties",arguments);
			this.baseClass="";
		},
		postCreate: function() {
			// summary: create store, read preset tags, set input value, subscribe events
			// needs to be done BEFORE inherited

			// read preset tags
			if (typeof(this.presetTags) == "string") {
				this.presetTags = this._splitTags(this.presetTags);
			} else {
				this.presetTags = $A();
			}
			// add preset to value group
			var valueGrouped = parent.epages.cartridges.de_epages.content.widget.valueGrouped;
			// added compatiblity to previous tageditor
			if(dojo.isArray(valueGrouped[this.group])){
				this.presetTags.merge(valueGrouped[this.group]);
				valueGrouped[this.group] = undefined;
			}
			// create tag source
			if (valueGrouped[this.group] === undefined) {
				valueGrouped[this.group] = new(eval(this.storeType))(this.id);
			}
			if (this.presetTags.length) {
				valueGrouped[this.group].mergeIn(this.presetTags);
			}
			if (typeof(this.value) == "string") {
				this.value = this._splitTags(this.value);
			}
			this.store = valueGrouped[this.group];

			// remove dojo magic, someone somewhere deep in dojo sets an id on the input
			this.focusNode.removeAttribute("id");
			this.focusNode = new epages.widget.FormElement({}, this.focusNode).elementNode;
			if (this.delimiter) {
				this.focusNode.value = this.value.join(this.delimiter + ' ');
			} else if(this.value.length){
				this.focusNode.value = this.value[0];
			} else {
				this.focusNode.value = "";
			}
			this.inherited("postCreate",arguments);

			if(this.description.length > 1) {
				this.focusNode.setAttribute("description", this.description);
			}
			//
			this._updatevalue();
			this.connect(this.focusNode, "onkeyup", "_evaluateInput");
			epages.topDojo.subscribe('Createobjectbutton/objectCreated',this,"hide");
			epages.topDojo.subscribe('Createobjectbutton/closed',this,"hide");

			dojo.forEach(dojo.query('.dijitPlaceHolder',this.domNode),function(item){
				dojo.destroy(item);
			});
		},
		_getQueryString: function(/*String*/ text){
			// overwrite dijit.form.ComboBoxMixin
			// summary: add trim
			return dojo.string.trim(dojo.string.substitute(this.queryExpr, [text]));
		},
		_showResults: function(/*String*/ key,/*Sting?*/lastTyped){
			// - changed popup class
			// - set _activeTagIndex, _editAtLastEl
			if (this.delimiter) {
				var tagList = this.focusNode.value;
				var caretPosition = this._getCaretPos(this.focusNode);
				var countTags = tagList.substr(0, caretPosition).match(new RegExp(this.delimiter, 'g'));
				this._activeTagIndex = countTags ? countTags.length : 0;
				if (!tagList.substr(caretPosition).match(new RegExp(this.delimiter, 'g'))) {
					this._editAtLastEl = true;
				}
				else {
					this._editAtLastEl = false;
				}
			}
			if(!this._popupWidget){
				// create the suggest popup
				var popupId = this.id + "_popup";
				this._popupWidget = new epages.cartridges.de_epages.content.widget._TagEditorMenu({
					onChange: dojo.hitch(this, function(evt){
						this._selectOption(evt);
						if (this.delimiter && evt.target != this._popupWidget.nextButton &&
							evt.target != this._popupWidget.previousButton && this._editAtLastEl) {
							// if last tag is edited and tag is selected add delimitter
							this.focusNode.value = this.focusNode.value + this.delimiter+" ";
						}
					}),
					id: popupId
				});
				dijit.removeWaiState(this.focusNode,"activedescendant");
				dijit.setWaiState(this.focusNode,"owns",popupId); // associate popup with focusNode
			}
			// create a new query to prevent accidentally querying for a hidden
			// value from FilteringSelect's keyField
			var query = dojo.clone(this.query); // #5970
			this._lastInput = lastTyped ? lastTyped : key; // Store exactly what was entered by the user.
			this._lastQuery = query[this.searchAttr] = this._getQueryString(key);
			// #5970: set _lastQuery, *then* start the timeout
			// otherwise, if the user types and the last query returns before the timeout,
			// _lastQuery won't be set and their input gets rewritten
			this.searchTimer=setTimeout(dojo.hitch(this, function(query, _this){
				this.searchTimer = null;
				var fetch = {
					queryOptions: {
						ignoreCase: this.ignoreCase,
						deep: true
					},
					query: query,
					onBegin: dojo.hitch(this, "_setMaxOptions"),
					onComplete: dojo.hitch(this, "_openResultList"),
					onError: function(errText){
						_this._fetchHandle = null;
						console.error('dijit.form.ComboBox: ' + errText);
						dojo.hitch(_this, "_hideResultList")();
					},
					start: 0,
					count: this.pageSize,
					origKey: key,
					tagEditorId: this.id // exclude tags of own id
				};
				dojo.mixin(fetch, _this.fetchProperties);
				this._fetchHandle = _this.store.fetch(fetch);

				var nextSearch = function(dataObject, direction){
					dataObject.start += dataObject.count*direction;
					// #4091:
					//		tell callback the direction of the paging so the screen
					//		reader knows which menu option to shout
					dataObject.direction = direction;
					this._fetchHandle = this.store.fetch(dataObject);
				};
				this._nextSearch = this._popupWidget.onPage = dojo.hitch(this, nextSearch, this._fetchHandle);
			}, query, this), this.searchDelay);
		},
		_startSearch: function(/*String*/ key,/*Sting?*/lastTyped){
			// overwrite dijit.form.ComboBoxMixin
			this._showResults(key,lastTyped);
		},
		_announceOption: function(/*Node*/ node){
			// summary:
			//		a11y code that puts the highlighted option in the focusNode.
			//		This way screen readers will know what is happening in the
			//		menu.
			// overwrite dijit.form.ComboBoxMixin
			if(!node){
				return;
			}
			// pull the text value from the item attached to the DOM node
			var newValue;
			if( node == this._popupWidget.nextButton ||
				node == this._popupWidget.previousButton){
				this.item = undefined;
				this.value = '';
			}else{
				newValue = this.inputLabelFunc(node.item, this.store);
				// get the text that the user manually entered (cut off autocompleted text)
				this.focusNode.value = this.focusNode.value.substring(0, this._lastInput.length);
				// set up ARIA activedescendant
				dijit.setWaiState(this.focusNode, "activedescendant", dojo.attr(node, "id"));
				// autocomplete the rest of the option to announce change
				this._autoCompleteText(newValue);
			}
		},
		_autoCompleteText: function(/*String*/ text){
			// overwrite dijit.form.ComboBoxMixin
			var fn = this.focusNode;
			// IE7: clear selection so next highlight works all the time
			var oldCpos = this._getCaretPos(fn);
			dijit.selectInputText(fn, fn.value.length);
			// does text autoComplete the value in the focusNode?
			var newCpos = this._getCaretPos(fn);
			// only try to extend if we added the last character at the end of the input
			if((newCpos+1) > fn.value.length){
				// only add to input node as we would overwrite Capitalisation of chars
				// actually, that is ok
				var tagList = fn.value;
				if (this.delimiter) {
					var tlSplit = tagList.split(this.delimiter);
					if(tlSplit.length>this._activeTagIndex){
						// replace old with new tag but keep leading and trailing spaces
						tlSplit[this._activeTagIndex] = tlSplit[this._activeTagIndex].replace(/^(\s*).*(\s*)$/,"$1"+text+"$2");
						// calculate chars to select
						var selectEnd = tlSplit.slice(0,this._activeTagIndex+1).join(this.delimiter).length;
						fn.value = tlSplit.join(this.delimiter);
						dijit.selectInputText(fn, oldCpos,selectEnd);
					}
				} else {
					fn.value = tagList.replace(/^(\s*).*(\s*)$/,"$1"+text+"$2");
					dijit.selectInputText(fn, oldCpos);
				}

			}
		},

		_startSearchFromInput: function(){
			// overwrite dijit.form.ComboBoxMixin
			// fix for multi tag
			// calculate tag which is currently under edit
			var tagList = this.focusNode.value;
			var caretPosition = this._getCaretPos(this.focusNode);
			var tag = this._getTagAt(caretPosition, tagList);
			this._startSearch(tag.replace(/([\\\*\?])/g, "\\$1"),this.focusNode.value.replace(/([\\\*\?])/g, "\\$1"));
		},
		_startSearchAll: function(){
			// overwrite dijit.form.ComboBoxMixin
			// fix for multi tag
			this._startSearch('',this.focusNode.value.replace(/([\\\*\?])/g, "\\$1"));
		},
		_getTagAt: function(/*int*/position, /*string*/tagList) {
			// summary: recieve the tag from the position of the caret
			// return string
			if (this.delimiter) {
				var leftPos = tagList.substr(0, position).lastIndexOf(this.delimiter);
				leftPos = (leftPos == -1 ? 0 : leftPos + 1);
				var rightPos = tagList.substr(position).indexOf(this.delimiter);
				rightPos = (rightPos == -1 ? tagList.length : rightPos + position);
				return tagList.substring(leftPos, rightPos);
			} else {
				return tagList;
			}
		},
		_evaluateInput: function(evt) {
			// summary: handle key input
			this._updatevalue();
			if (this.delimiter && evt.keyCode == dojo.keys.ENTER && this._editAtLastEl) {
				// add delimiter if edited tag was the last one
				this.focusNode.value = this.focusNode.value + this.delimiter+" ";
			}
		},
		_updatevalue: function() {
			// summary: set the current value to make it accessable
			this.value = this._splitTags(this.focusNode.value);
			this.store.setValue(this.id, this.value);
			dojo.publish(this.id + "/onChange", [{ tags: this.value }]);
		},

		_splitTags: function(/*String*/tagList) {
			// summary: split and trim tagList on delimiter
			// return $A
			var finalTagArray = [];
			if (this.delimiter) {
				var tagArray = tagList.split(this.delimiter);
				for( var i=0,iLength=tagArray.length ; i<iLength ; i++ ) {
					var el = tagArray[i];
					el = el.replace(/^\s*/, "");
					el = el.replace(/\s*$/, "");
					if (el != "") {
						finalTagArray.push(el);
					}
				}
			} else {
				tagList = tagList.replace(/^\s*/, "");
				tagList = tagList.replace(/\s*$/, "");
				if (tagList != "") {
					finalTagArray.push(tagList);
				}
			}
			return $A(finalTagArray);
		},

		getValue: function() {
			return this.focusNode.value;
		},

		setValue: function(newValue) {
			if(newValue) {
				this.value = this.focusNode.value = newValue;
			} else {
				this.value = this.focusNode.value = '';
			}
		},

		hide: function(){
			this._hideResultList();
		},

		labelFunc: function(/*item*/ item, /*dojo.data.store*/ store){
			var itemvalue = store.getValue(item, this.searchAttr);
			var result;
			if(typeof(itemvalue) == 'object') {
				result = itemvalue.labelvalue;
			} else {
				result = itemvalue; // String
			}

			// beautify
			if(this.focusNode.value) {
				var fnv = this.focusNode.value; // 'de'
				var regex = new RegExp(fnv, "g");
				result = result.replace(regex, '<strong>'+fnv+'</strong>'); // 'de_asdasfdasdf'
			}
			return result;
		},

		inputLabelFunc: function(/*item*/ item, /*dojo.data.store*/ store){
			var itemvalue = store.getValue(item, this.searchAttr);
			if(typeof(itemvalue) == 'object') {
				return itemvalue.inputvalue;
			}
			return itemvalue; // String
		}
	}
);

dojo.declare("epages.cartridges.de_epages.content.widget._TagEditorStore", null, {
	availableTags: $A(),
	currentValues: {},
	constructor: function(){},

	mergeIn : function(/*String[]E*/tags){
		// summary: add tags to preset tags
		this.availableTags.merge(tags);
		this.availableTags.unique();
	},
	setValue : function(/*String*/id,/*String[]*/tags){
		// summary: set value of one of the tageditors of the group
		if (tags.length) {
			// prevent empty tags
			this.currentValues[id] = tags;
		}
	},
	getValue: function(	/* item */ item,
						/* attribute-name-string */ attribute,
						/* value? */ defaultValue){
		return item;
	},

	isItemLoaded: function(/* anything */ something){
		return true;
	},

	getFeatures: function(){
		return {"dojo.data.api.Read": true, "dojo.data.api.Identity": true};
	},

	_fetchItems: function(	/* Object */ args,
							/* Function */ findCallback,
							/* Function */ errorCallback){
		// summary:
		//		See dojo.data.util.simpleFetch.fetch()
		if(!args.query){ args.query = {}; }
		if(!args.query.name){ args.query.name = ""; }
		if(!args.queryOptions){ args.queryOptions = {}; }
		// merge preset tags and tags from the editors
		var tags = $A();
		for(var v in this.currentValues){
			if (v != args.tagEditorId) {
				tags.merge(this.currentValues[v]);
			}
		}
		tags.merge(this.availableTags);
		tags.unique();
		var matcher = dojo.data.util.filter.patternToRegExp(args.query.name, args.queryOptions.ignoreCase),
		items = tags.match(matcher);
		if(args.sort){
			items.sort(dojo.data.util.sorter.createSortFunction(args.sort, this));
		}
		findCallback(items, args);
	},

	close: function(/*dojo.data.api.Request || args || null */ request){
		return;
	},

	getLabel: function(/* item */ item){
		return item.innerHTML;
	},

	getIdentity: function(/* item */ item){
		return item;
	}
});
//Mix in the simple fetch implementation to this class.
dojo.extend(epages.cartridges.de_epages.content.widget._TagEditorStore,dojo.data.util.simpleFetch);

}

if(!dojo._hasResource["epages.cartridges.de_epages.content.widget.JsonTagEditor"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.content.widget.JsonTagEditor"] = true;
dojo.provide("epages.cartridges.de_epages.content.widget.JsonTagEditor");



dojo.declare("epages.cartridges.de_epages.content.widget._JsonTagEditorStore",
			 epages.cartridges.de_epages.content.widget._TagEditorStore, {
	// parent needs to define a string which is used as subscribe/publish key
	unique:			null,

	constructor: function(unique){
		this.unique = unique;
		dojo.subscribe(this.unique + '/onNewSearchResults', this, "_handleJsonResult");
	},

	_fetchItems: function(	/* Object */ args,
							/* Function */ findCallback,
							/* Function */ errorCallback){
		// summary:
		//		See dojo.data.util.simpleFetch.fetch()
		if(!args.origKey){ args.origKey = ""; }
		// async call to json request function epages.cartridges.de_epages.content.widget.SmartSearchInput
		dojo.publish(this.unique + '/onEvaluateInput', [ args.origKey,dojo.mixin(args,{"findCallback":findCallback})]);
	},
	_handleJsonResult : function(items,args){
		// summary: recieve json result, sort and push it to callback
		if(args.sort){
			items.sort(dojo.data.util.sorter.createSortFunction(args.sort, this));
		}
		if (args.findCallback) {
			args.findCallback(items, args);
		}
	},
	getLabel: function(/* item */ item){
		return item.innerHTML;
	}
});

dojo.declare(
	"epages.cartridges.de_epages.content.widget.JsonTagEditor",
	epages.cartridges.de_epages.content.widget.TagEditor,
	{
		/**
		 * public properties
		 */
		//integer - limited by SMART_PRODUCT_SEARCH_RESULT_COUNT Perl constant
		pageSize:    10,

		// searchDelay: Integer
		//		Delay in milliseconds between when user types something and we start
		//		searching based on that value
		searchDelay: 0,
		// disable multiple tags
		delimiter: null,
		placeholder: '',
		storeType: "epages.cartridges.de_epages.content.widget._JsonTagEditorStore",
		labelType: "html",
    	submitOnEnter: true,	// flag that decides if the form is submitted by using the submit-Event (true) or
                          		// by trigger the event using the fire method (false)
		postCreate: function() {
			this.inherited('postCreate', arguments);
      this.submitOnEnter = epages.string.toBoolean(this.submitOnEnter);
    },
		_onKeyPress: function(/*Event*/ evt){
			var key = evt.charOrCode;
			if(evt.keyCode == dojo.keys.ENTER) {
				if(!this._isShowingNow){
          if(this.submitOnEnter){
					this.focusNode.form.submit();
          }else{
            epages.event.fire(dojo.query('input[type=submit]', this.focusNode.form)[0], "click");
          }
				}
			}
			this.inherited("_onKeyPress",arguments);
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.content.widget.SmartSearchInput"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.content.widget.SmartSearchInput"] = true;
dojo.provide("epages.cartridges.de_epages.content.widget.SmartSearchInput");




dojo.declare(
	"epages.cartridges.de_epages.content.widget.SmartSearchInput",
	[dijit._Widget, dijit._Templated],
	{
		/**
		 * public properties
		 */
		url                     : '?',  // url for the json action(s)
		ViewAction              : 'JSONSmartSearchObjects',
		inputName               : 'SmartSearch',
		inputStyle              : 'width: 200px',
		value                   : '',    // last input value (i.e. if formerror)
		objectId                : epages.vars.SiteID || '',

		/**
		 * private properties
		 */
		_lastInputValue         : null,  // the last search value
		_timeoutMarker          : null,
		_lastSeachResultCount   : null,
		_searchStartDelay       : 400,   // delay after which time no key was pressed, the search should be started. In msec.
		_minCharactersForSearch : 1,     // how many characters can a user enter before triggering the search

		/**
		 * dojo widget properties
		 */
		templateString:"<span>\n  <span\n    dojoType=\"epages.cartridges.de_epages.content.widget.JsonTagEditor\"\n    availableTags=\"\"\n    dojoAttachPoint=\"SmartSearchBox\"\n    value=\"${value}\"\n    type=\"text\"\n    name=\"${inputName}\"\n    style=\"${inputStyle}\"\n    group=\"\"\n    description=\"\"\n  ></span>\n</span>\n",
		widgetsInTemplate:  true,

		postCreate: function() {
			this.inherited("postCreate",arguments);
			if(this.value) {
				this.SmartSearchBox.setValue(this.value);
			}
			dojo.subscribe(this.SmartSearchBox.id + '/onEvaluateInput', this, "searchBoxKeyUp");
		},

		searchBoxKeyUp: function(/*String*/textInput,/*Object?*/callbackArgs) {
			// fire keyup evt
			// REMOVED dojo.publish(this.id+'/keyup', [ evt ]);
			// check if value changed
			if(this._lastInputValue == textInput || textInput.length <= this._minCharactersForSearch) {
				return;
			}
			// check if last request returned 0 results and if entered value is not the same string plus more chars
			if(this._lastSeachResultCount !== null && this._lastSeachResultCount != '') {
				if(this._lastSeachResultCount === 0 &&
				   textInput.match(new RegExp('^' + this._lastInputValue))) {
				  this._lastInputValue = textInput;
					return;
				}
			}
			// update values
			this._lastInputValue = textInput;
			this.value = textInput;

			// delay requests if keys pressed too fast
			if(this._timeoutMarker) {
				window.clearTimeout(this._timeoutMarker);
			}
			var self = this;
			this._timeoutMarker = window.setTimeout(function(){
				// do search
				self.queryObjectAliases(callbackArgs);
			}, this._searchStartDelay);
		},

		getValue: function() {
			return this.SmartSearchBox.getValue();
		},

		queryObjectAliases: function(callbackArgs) {
			if(!this._lastInputValue) {
				return;
			}
			var inputValue = this._lastInputValue;
			var me = this;
			var json = new epages.io.Json();
			var result = json.loadAsync(this.url,
			function(result){
				if(result.error || !result.data) {
					return;
				}
				// update tageditor available tags ... result.data
				me._lastSeachResultCount = parseInt(result.data.NumResults);
				dojo.publish(me.SmartSearchBox.id + '/onNewSearchResults', [result.data.Results,callbackArgs]);
			},
			{
				'ObjectID' 			: this.objectId,
				'ViewAction'		: this.ViewAction,
				'SearchString' 	: inputValue
			});
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.product.widget.SmartSearchProducts"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.widget.SmartSearchProducts"] = true;
dojo.provide("epages.cartridges.de_epages.product.widget.SmartSearchProducts");


dojo.declare(
	"epages.cartridges.de_epages.product.widget.SmartSearchProducts",
	[epages.cartridges.de_epages.content.widget.SmartSearchInput],
	{
		/**
		 * public properties
		 */
		ViewAction:					'JSONSmartSearchProductAlias',
		inputName :					'NewProduct',
		placeholder: '',

		/**
		 * dojo widget properties
		 */
		templateString:"<span>\n  <span\n    dojoType=\"epages.cartridges.de_epages.content.widget.JsonTagEditor\"\n    availableTags=\"\"\n    dojoAttachPoint=\"SmartSearchBox\"\n    value=\"${value}\"\n    type=\"text\"\n    name=\"${inputName}\"\n    style=\"${inputStyle}\"\n    group=\"\"\n    description=\"\"\n    labelSliceLimit=\"20\"\n    submitOnEnter=\"false\"\n    placeholder=\"${placeholder}\"\n  ></span>\n</span>\n",

		// overloads smartsearchinput's method
		queryObjectAliases: function(callbackArgs) {
			if(!this._lastInputValue) {
				return;
			}
			var inputValue = this._lastInputValue;
			var me = this;
			var json = new epages.io.Json();
			var result = json.loadAsync(this.url,
			function(result){
				if(result.error || !result.data) {
					return;
				}
				// update tageditor available tags ... result.data
				me._lastSeachResultCount = parseInt(result.data.NumResults);

				// mapping for name attribute
				var fixedResults = [];
				var results = result.data.Results;
				var len = result.data.NumResults;

				for(var i=0; i<len; i++) {
					fixedResults[i] = {};
					fixedResults[i].inputvalue = results[i].alias;
					fixedResults[i].labelvalue = results[i].alias;
					if(results[i].name) {
						 fixedResults[i].labelvalue += ' <span class="SmartSearchProductsName">- ' + epages.format.slice(results[i].name, 23, true) + '</span>';
					}
				}
				dojo.publish(me.SmartSearchBox.id + '/onNewSearchResults', [fixedResults, callbackArgs]);
			},
			{
				'ObjectID' 			: this.objectId,
				'ViewAction'		: this.ViewAction,
				'SearchString' 	: inputValue
			});
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.order.sendorderdocument"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.order.sendorderdocument"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.order.sendorderdocument $Revision: 1.14 $

*/

dojo.provide("epages.cartridges.de_epages.order.sendorderdocument");






epages.cartridges.de_epages.order.SendOrderDocument = {

	errorMap: {
		EMAIL_MISSING:															"",
		InvalidMailAddress:													"",
		SUBJECT_MISSING:														"",
		MISSING_FROM:																"",
		No_Recipients:															"",
		Invalid_Recipient:													"",
		ERROR_CREATING_PDF:													""
	},

	localizedStrings: {
		sendDocumentAsPDF:													"",
		waitWhilePDFGenerating:											"",
		documentSentHeadline:												"",
		documentSentText:														"",
		sendMail:																		"",
		cancel:																			"",
		error:																			""
	},

	sendDocumentAsMailDialog: null,
	_translateStrings: function(dialogContent) {
        // summary:
	//	Retrieve all the errorMap / localizedStrings properties.
		if(this.errorMap.EMAIL_MISSING.length < 2) { // do this only once
			var tmpContainer = document.createElement("div");
			tmpContainer.className = "HideElement";
			tmpContainer.innerHTML = dialogContent;
			eval(tmpContainer.getElementsByTagName("script")[0].innerHTML);
		}
	},

	_showBusyLayer: function() {
		dojo.publish("uimessage/startBusy", ["sendorderdocument_busy", this.localizedStrings.waitWhilePDFGenerating]);
	},

	_hideBusyLayer: function() {
		dojo.publish("uimessage/stopBusy", ["sendorderdocument_busy"]);
	},
	_insertDialogMessage: function(isError, messageHeadline, messageText) {
        // summary:
	//		Pass the status message of this module to the user via .DialogMessage.
	// description:
	//		Can be the error or success message.
		// this is tricky because dialog areas don't have a fixed id
		// we're using the <form> (which has to be there in every case) as fallback
		var dialogNode = dojo.query("div.TabPage > form > div.Dialog")[0] || dojo.query("div.TabPage > form")[0];

		var messageNode = $("SendOrderDocumentResult") || document.createElement("div");
		messageNode.id = "SendOrderDocumentResult"
		messageNode.className = "DialogMessage " + (isError ? "MessageWarning" : "MessagePositiveResult");
		messageNode.innerHTML = "<h3>" + messageHeadline + "</h3><p>" + messageText + "</p>";

		dialogNode.insertBefore(messageNode, dialogNode.firstChild);
	},

	_throwError: function(errorMessage) {
		this._insertDialogMessage(true, this.localizedStrings.error, errorMessage || this.errorMap.ERROR_CREATING_PDF);
		this._hideBusyLayer();
	},

	_onMailSent: function() {
		this._insertDialogMessage(false, this.localizedStrings.documentSentHeadline, this.localizedStrings.documentSentText);
		this._hideBusyLayer();
	},

	_onResponse: function(response) {
		if(!response || response.error) {
			// hard error with no further information
			this._throwError(this.errorMap.ERROR_CREATING_PDF);
		}else if(response.data.mailSent) {
			if(epages.string.toBoolean(response.data.mailSent)) {
				// everything fine
				this._onMailSent();
			}else {
				// soft error with description
				this._throwError(this.errorMap[response.data.reason]);
			}
		}
	},

	_removeErrorMessageFromInput: function(evt) {
			dojo.removeClass(evt.currentTarget, "DialogError");
			dojo.publish("uimessage/hide");
	},

	_onSendButtonClicked: function(objectID) {
        // summary:
	//		Trigger the xhr process or init error handling.
		var sendOrderDocumentForm = $("sendOrderDocumentForm");
		var inputPosition = $E(sendOrderDocumentForm.To).getAbsolutePosition(dojo.body());

		if(!sendOrderDocumentForm.To.value) {
			dojo.publish("uimessage/show", [this.localizedStrings.error, this.errorMap.EMAIL_MISSING, "Bubble", {
				x:					inputPosition.x,
				y:					inputPosition.y + sendOrderDocumentForm.To.offsetHeight - 5,
				sizeClass:	"Small"
			}]);
			dojo.addClass(sendOrderDocumentForm.To, "DialogError");
			dojo.connect(sendOrderDocumentForm.To, "focus", this, "_removeErrorMessageFromInput");
			return;
		}else if(!sendOrderDocumentForm.To.value.match("@") || sendOrderDocumentForm.To.value.length < 3) {
			dojo.publish("uimessage/show", [this.localizedStrings.error, this.errorMap.InvalidMailAddress, "Bubble", {
				x:					inputPosition.x,
				y:					inputPosition.y + sendOrderDocumentForm.To.offsetHeight - 5,
				sizeClass:	"Small"
			}]);
			dojo.addClass(sendOrderDocumentForm.To, "DialogError");
			dojo.connect(sendOrderDocumentForm.To, "focus", this, "_removeErrorMessageFromInput");
			return;
		}
		if(!sendOrderDocumentForm.Subject.value) {
			inputPosition = $E(sendOrderDocumentForm.Subject).getAbsolutePosition(dojo.body());

			dojo.publish("uimessage/show", [this.localizedStrings.error, this.errorMap.SUBJECT_MISSING, "Bubble", {
				x:					inputPosition.x,
				y:					inputPosition.y + sendOrderDocumentForm.Subject.offsetHeight - 5,
				sizeClass:	"Small"
			}]);
			dojo.addClass(sendOrderDocumentForm.Subject, "DialogError");
			dojo.connect(sendOrderDocumentForm.Subject, "focus", this, "_removeErrorMessageFromInput");
			return;
		}

		this._showBusyLayer();

		var msgElements = new Object();
		dojo.forEach(dojo.query("[name]", sendOrderDocumentForm), function(item) {
			if(item.value) {
				// collect all form values and append them to the message object
				msgElements[item.name] = item.value;
			}
		});

		var _this = this;
		jQuery.ajax({
			type: "POST",
			url: "?ObjectID=" + objectID,
			data: msgElements,
			dataType: "json"
			})
			.done(function( response ) {
				_this._onResponse({ "data": response });
			})
			.fail(function(error){
				_this._throwError(_this.errorMap.ERROR_CREATING_PDF);
			});

		this.sendDocumentAsMailDialog.hide();
	},

	openDialog: function(docAlias /* String */, objectID /* String */, languageID /* String */, TemplateAction /* String */) {
        // summary:
        //		Open the dialog for sending a mail with pdf attached.
        // description:
        //		The opened dialog triggers the method which will generate the pdf equivalent to the current order document.
        // docAlias:
        //		The alias (TLE) for the document.
        // objectID:
        //		The ObjectID (TLE) for the document.
        // languageID:
        //		The LanguageID (TLE) for the document.
		this.sendDocumentAsMailDialog = $$("sendDocumentAsMailDialog");
		if(this.sendDocumentAsMailDialog) {this.sendDocumentAsMailDialog.destroy()} // the dialog was opened before

		var existWidget = $$('sendOrderDocumentForm');
		if( existWidget ){ existWidget.destroy(); } // the dialog was opened before, destroy form

		var dialogContent = (new epages.io.Json()).loadSync("?", { // maybe async would do? Sync frezes the UI.
			ViewAction:         "JSONSnippet",
			TemplateAction:     (TemplateAction || "MBO-ViewSendOrderDocumentAsPDFMailDialog"),
			TemplateLanguageID: (languageID || ""),
			ObjectID:           (objectID || ""),
			Doc:                (docAlias || "")
		}).data.snippet;
		this._translateStrings(dialogContent);


		this.sendDocumentAsMailDialog = new epages.widget.Modaldialog({
			id: "sendDocumentAsMailDialog",
			options: {
				title : this.localizedStrings.sendDocumentAsPDF,
				width : 450,
				scroll: "hidden",
				content: dialogContent
			},
			buttons: [{
				label: this.localizedStrings.sendMail,
				onclick: dojo.hitch(this, function(){this._onSendButtonClicked(objectID)})
			},{
				label: this.localizedStrings.cancel,
				onclick: dojo.hitch(this, function() {
					this.sendDocumentAsMailDialog.hide();
				})
			}]
		});

		dojo.connect(this.sendDocumentAsMailDialog.domNode, "mouseup", function() {
			// hide all error messages
			dojo.publish("uimessage/hide");
		});

		dojo.connect(this.sendDocumentAsMailDialog.domNode, "keypress", dojo.hitch(this, function(evt) {
			if(evt.keyCode === dojo.keys.ENTER && evt.target.tagName !== "TEXTAREA") {
				// enable the user to submit the form via keyboard
				this._onSendButtonClicked(objectID);
			}
		}));

		dojo.body().appendChild(this.sendDocumentAsMailDialog.domNode);
		this.sendDocumentAsMailDialog.show();

		// for usability enhancements we select the content of the first input element
		var firstInput = dojo.query("input[type=text]", this.sendDocumentAsMailDialog.domNode)[0];
		setTimeout(dojo.hitch(this, function() {
			epages.event.fire(firstInput, "mouseup");
			try {
				firstInput.focus();
				firstInput.select();
			}catch(e) {}
		}), this.sendDocumentAsMailDialog.duration * 1.2); // the animation resets the focus, so we have to wait until it finished
	}
};

}

if(!dojo._hasResource["epages.cartridges.de_epages.product.widget.DeleteSlideshowImage"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.widget.DeleteSlideshowImage"] = true;
/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.
*/
dojo.provide("epages.cartridges.de_epages.product.widget.DeleteSlideshowImage");


dojo.declare(
	"epages.cartridges.de_epages.product.widget.DeleteSlideshowImage",
	[ epages.widget.DeleteFileOnServer ],
	{
		onExecute: function () {
			

			var params = {
				'ObjectID'			: this.objectId,
				'ChangeAction' 	: 'SaveFiles',
				'Delete' 				: '1',
				'DeleteFile'		: this.fileName,
				'ACCEPT'				: this.confirm ? 1 : 0
			};
			var json = new epages.io.Json();
			json.loadAsync(this.url, dojo.hitch(this, 'onExecution'), params);
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.product.widget.ProductPickerList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.widget.ProductPickerList"] = true;
/*
  Copyright (c) 2006-2010, ePages GmbH
  All Rights Reserved.

  +-----+---------------+--------------------
  |  _  |               |
  | |_| | tableHead[0]  | tableHead[1]  ...
  |_____|_______________|____________________
  |     |               |
  | |x| | content[0][0] | content[0][1] ...
  |_____|_______________|____________________
  |  .
  |  .
  |  .
  |__________________________________________
  |
  | Page x of y  |<  < 1 2 3 >  >|   Count: z
  +------------------------------------------

*/
dojo.provide("epages.cartridges.de_epages.product.widget.ProductPickerList");//an dieser Stelle wird das neue Widget registriert

dojo.declare("epages.cartridges.de_epages.product.widget.ProductPickerList", [epages.widget.LocalizedWidget], {
    /**
     * public properties
     */
    tableHead            : ["Name"],   // captions of columns
    columnNames          : ["NameOrAlias"], //object attribute name for each column
    displayCheckbox      : true,       //display a checkbox in front of each item and a check-all checkbox
    requestObjectID      : undefined,  //#Shop.ProductFolder.ID
		maxPagerNumberButtons: 5,					//choose only even numbers

    /**
     * widget settings
     */
    widgetsInTemplate : true,
    templateString:"<div dojoAttachPoint=\"widgetRoot\" style=\"z-Index:10001;\">\n  <form>\n  <table dojoType=\"epages.widget.ContentList\" class=\"ContentList\">\n    <thead>\n      <tr dojoAttachPoint=\"tableHeadLine\">\n        <td class=\"Checkbox\" dojoAttachPoint=\"checkAllCheckbox\">\n          <input type=\"text\" class=\"Checkbox RunButtonTrigger\" value=\"Checkbox\" dojoType=\"epages.widget.FormElement\" />\n        </td>\n      </tr>\n    </thead>\n    <tfoot>\n      <tr>\n       <td dojoAttachPoint=\"pagerSizeNode\" colspan=\"${_cols}\">\n        <div class=\"Pager\" dojoAttachPoint=\"pagerBar\" style=\"position:relative\">\n       \n        </div>\n       </td>\n      </tr>\n    </tfoot>\n    <tbody dojoAttachPoint=\"containerNode\">\n    </tbody>\n  </table>\n  </form>\n</div>\n",
    translationName   : dojo.moduleUrl('epages.cartridges.de_epages.product.widget', "templates/translation"),

    /**
     * private properties
     */
    _cols              : 0,
    _pageChangeRequest : {
        'ObjectID'          : '', // Product folder
        'ViewAction'        : 'JSONSearchProducts',
        'WildSearchString'  : '',
        'IsAppointment'     : '',
        'PageSize'          : 10,
        'OrderBy'           : 'NameOrAlias',
        'OrderDesc'         : 0,
        'IsNotSubProduct'   : 1
    },
    _checkAllCheckbox : [], // array of all check-all checkboxes (one item for each page)
    _childsOnPage     : [], // items on the currently visible page
    _pager: {
      currentPage : 0,
      itemCount: 0,
      maxPage: 0,
      bufferedPages : [], // one item for each page of the current search which was already visible
      connects : []
    },

    postMixInProperties: function() {
    	this.inherited("postMixInProperties", arguments);
    	this._cols = this.tableHead.length;
    	// calculate column count of the table and set pager cell to fit it
    	if(this.displayCheckbox) {
    		this._cols++;
    	}
    },

    postCreate: function() {
      // summary: create table column headlines, calculate column count and show an empty page
      this.inherited("postCreate", arguments);
      this._pageChangeRequest.ObjectID = this.requestObjectID;
      dojo.forEach(this.tableHead,function(el){
        var tdNode = document.createElement("td");
        tdNode.innerHTML = el;
        this.tableHeadLine.appendChild(tdNode);
      },this);

      // show an empty page
      this._createVisibleChildren(0);
    },
    requestPage : function(/*Integer*/ page,/*Boolean?*/ isNewSearch){
      // summary: request the content of a page of the current page from server or buffer
      if(!this._pageChangeRequest.ObjectID){
        console.error("Shop.PrductFolder.ID is missing");
        return;
      }
      if(this._pager.bufferedPages[page]){
        // page of the result was displayed before --> load saved page
        this._childsOnPage = this._pager.bufferedPages[page];
        this._setPagerButtons({"currentPage":page});
        this._createVisibleChildren(page);
      } else {
        // show loading image over table
        dojo.publish("interactionRestrictor/suspend", ["ProductPickerLoadPage", this.widgetRoot]);
        var json = new epages.io.Json();
        // request search results on current page
        json.loadAsync("?",
                       dojo.hitch(this,this.handleRequest,page),
                       dojo.mixin(this._pageChangeRequest,{'PagerPage': page+1}));
      }
    },
    handleRequest : function(/*Integer*/page,/*Object*/requestResult){
      // summary: set pager values for the requestet page, show pager and load content
      epages.vars.requestResult = requestResult;
      dojo.publish("interactionRestrictor/permit", ["ProductPickerLoadPage"]);
      if(requestResult.error || !requestResult.data) {
        this._setPagerButtons({"itemCount":0,"maxPage":0});
        var errorMessage = "";
        if(requestResult.error.data.Errors.length == 1 &&
           requestResult.error.data.Errors[0].Name == "WildSearchString" &&
           requestResult.error.data.Errors[0].Reason == "STRING_EMPTY"){
           // user simply missed to put a search string in the textbox
           errorMessage = this.translate('noResults');
        } else {
           errorMessage = "An error occured while trying to retrieve search results.";
        }
        this._createfullTableRow(errorMessage);
        return;
      }
      // show pager
      this._setPagerButtons({"currentPage":page,
                             "maxPage":requestResult.data.CountOfPages,
                             "itemCount":requestResult.data.CountOfItems});

      // create table content
      this._childsOnPage = dojo.map(requestResult.data.SearchResults,function(el){
        return {_data:el,_node:{}};
      },this);
      this._createVisibleChildren(page);
    },
    pageUp:function(evt){
        // summary: changes the visible elemnts by paging one page up
    	dojo.stopEvent(evt);
      if(this._pager.currentPage+1 != this._pager.maxPage){
        var page = this._pager.currentPage + 1;
        this.requestPage(page);
      }
    },

    pageDown:function(evt){
        // summary: changes the visible elemnts by paging one page down
    	dojo.stopEvent(evt);
      if(this._pager.currentPage > 0){
        var page = this._pager.currentPage - 1;
        this.requestPage(page);
      }
    },

    pageTo: function(evt,/*Integer*/ page){
        // summary: changes the visible elemnts by paging to the given page
    	dojo.stopEvent(evt);
      if(page >= 0 && page < this._pager.maxPage){
        this.requestPage(page);
      }
    },
    _setPagerButtons: function(/*Object*/pagerValues){
      // summary: create the pager elements and display them
      // example: this._setPagerButtons({"currentPage":0,"maxPage":2,"itemCount":12})
      dojo.mixin(this._pager,pagerValues);
      var pagerHTML = "";
      var linknode = undefined;
      var linkNodePattern = document.createElement("a");
      linkNodePattern.href = "#";

      // clean up
      dojo.forEach(this._pager.connects,function(el){
        dojo.disconnect(el);
      });
      dojo.empty(this.pagerBar);
      // count of items is always displayed
      var node = dojo.create("div",{
        "class"     : "PagerCountOfItems",
        "innerHTML" : this.translate('Count')+': '+this._pager.itemCount
      },this.pagerBar);
      // create the whole page control elements and add them to dom
      if(this._pager.maxPage>1){
        dojo.create("div",{
          "class"     : "PagerAdditionalInfo",
          "innerHTML" : this.translate("Site")+' '+(this._pager.currentPage+1)+' '+this.translate("of")+' '+this._pager.maxPage
        },this.pagerBar);
        //go first and go previous page buttons
        if(this._pager.currentPage == 0){
          dojo.create("span",{
            "innerHTML" : '<i class="Opacity30 Sprite list_ico_s_paging_first" title="'+this.translate("FirstPage")+'"></i>',
            "class"     : "NoLink"
          },this.pagerBar);

          dojo.create("span",{
            innerHTML :'<i class="Opacity30 Sprite list_ico_s_paging_backward" title="'+this.translate("Back")+'"></i>',
            "class"   : "NoLink"
          },this.pagerBar);
        } else {
          linkNode = dojo.attr(linkNodePattern.cloneNode(true),{
            title     : this.translate("FirstPage"),
            innerHTML : '<i class="Sprite list_ico_s_paging_first" title="'+this.translate("FirstPage")+'"></i>'
          });
          this.pagerBar.appendChild(linkNode);
          this._pager.connects.push(dojo.connect(linkNode, 'onclick', this,function(evt){
            this.pageTo(evt,0);
          }));

          linkNode = dojo.attr(linkNodePattern.cloneNode(true),{
            title     : this.translate("Back"),
            innerHTML : '<i class="Sprite list_ico_s_paging_backward" title="'+this.translate("Back")+'"></i>'
          });
          this.pagerBar.appendChild(linkNode);
          this._pager.connects.push(dojo.connect(linkNode, 'onclick', this,'pageDown'));
        }
        // create numbers to navigate to a specific page
        var overhead = Math.floor(this._pager.currentPage+(this.maxPagerNumberButtons+1)/2)-this._pager.maxPage;
        overhead = Math.max(overhead,0);
        var startIndex = Math.floor(this._pager.currentPage-(this.maxPagerNumberButtons-1)/2)-overhead;
        startIndex = Math.max(startIndex,0);
        for(var i=startIndex;i<startIndex+this.maxPagerNumberButtons &&
        										 i<this._pager.maxPage;i++){
          if(i==this._pager.currentPage){
            linkNode = dojo.attr(linkNodePattern.cloneNode(true),{
              "class"     : 'SelectedItem',
              "innerHTML" : '<span>'+(i+1)+'</span>'
            });
            this.pagerBar.appendChild(linkNode);
          } else {
            linkNode = dojo.attr(linkNodePattern.cloneNode(true),"innerHTML",(i+1));
            this.pagerBar.appendChild(linkNode);
            this._pager.connects.push(dojo.connect(linkNode, 'onclick', this,function(evt){
              this.pageTo(evt,parseInt(evt.target.innerHTML)-1);
            }));
          }
        }
        // go next and go last page buttons
        if(this._pager.currentPage == this._pager.maxPage-1){
          dojo.create("span",{
            "class"     : 'NoLink',
            "innerHTML" : '<i class="Opacity30 Sprite list_ico_s_paging_forward" title="'+this.translate("Next")+'"></i>'
          },this.pagerBar);

          dojo.create("span",{
            "class"     : 'NoLink',
            "innerHTML" : '<i class="Opacity30 Sprite list_ico_s_paging_last" title="'+this.translate("LastPage")+'"></i>'
          },this.pagerBar);
        } else {
          linkNode = dojo.attr(linkNodePattern.cloneNode(true),{
            title     : this.translate("Next"),
            innerHTML : '<i class="Sprite list_ico_s_paging_forward" title="'+this.translate("Next")+'"></i>'
          });
          this.pagerBar.appendChild(linkNode);
          this._pager.connects.push(dojo.connect(linkNode, 'onclick', this, "pageUp"));

          linkNode = dojo.attr(linkNodePattern.cloneNode(true),{
            title     : this.translate("LastPage"),
            innerHTML : '<i class="Sprite list_ico_s_paging_last" title="'+this.translate("LastPage")+'"></i>'
          });
          this.pagerBar.appendChild(linkNode);
          this._pager.connects.push(dojo.connect(linkNode, 'onclick', this,function(evt){
            this.pageTo(evt,this._pager.maxPage-1);
          }));
        }
      }
    },
    _displayCheckAllOnPage : function(/*Integer*/ page){
      // summary: display a checkbox which checks all item checkboxes at once
      dojo.empty(this.checkAllCheckbox);
      // checkbox is only created if it page was not shown before
      if(!this._checkAllCheckbox[page]){
        var inputNode = dojo.create("input",{
          "type"  : "checkbox",
          "value" : "Checkbox",
          "class" : "Checkbox RunButtonTrigger"
        });
        // checkboxes are always widgets
        inputNode = new epages.widget.FormElement({ },inputNode).elementNode;
        this._checkAllCheckbox[page] = inputNode;
        this.connect(inputNode,"onclick", "_setAllVisible");
      }
      this.checkAllCheckbox.appendChild(this._checkAllCheckbox[page]);
    },

		_createfullTableRow : function(/*String*/ message){
			dojo.empty(this.containerNode);
			if(epages.Browser.engine=="MSIE"){
      	dojo.create("tr",{innerHTML:"<td colspan="+this._cols+">"+message+"</td>"},this.containerNode);
    	} else {
    		this.containerNode.innerHTML = "<tr><td colspan="+this._cols+">"+message+"</td>";
    	}
		},
    _createVisibleChildren: function(/*Integer*/ page){
      // summary: creates table rows for the current on this page of list visible children
      // save items and destroy old visible Children
      if(this.displayCheckbox){
        this._displayCheckAllOnPage(page);
      }
      //remove old content
      //dojo.empty(this.containerNode);
      // IE can't handle dojo.empty
      while(this.containerNode.childNodes.length>0){
      	this.containerNode.removeChild(this.containerNode.childNodes[0]);
      }
      // save content for later use
      this._pager.bufferedPages[page] = this._childsOnPage;
      //create visible items
      if(this._childsOnPage.length == 0){
      	this._createfullTableRow(this.translate('noResults'));
      } else {
        for( var i=0,iLength=this._childsOnPage.length ; i<iLength ; i++ ) {
          var elm = this._childsOnPage[i];
          if(elm){
            if(!elm._node.trNode){
              // calculate item content
              var contentHTML = "";
              var attr = {};
              if(i%2==0){
              	attr["class"] = "alternate";
              }
              elm._node.trNode = dojo.create("tr",attr);
              // add item content
              var timestamp = (new Date()).getTime(); // make it unique
              // column cell content
              for( var j=0,jLength=this.columnNames.length ; j<jLength ; j++ ){
                dojo.create("td",{innerHTML: '<label style="#display:inline-block;#width:300px;" for="checkbox'+elm._data.ObjectID+""+timestamp+'">'+elm._data[this.columnNames[j]]+'</label>'},elm._node.trNode);
              }
              // create checkbox
              var tdNode = dojo.create("td",{
                "class" : "Checkbox"
              },elm._node.trNode,"first");
              elm._node.inputNode = dojo.create("input",{
                "type"  : "text",
                "id"    : "checkbox"+elm._data.ObjectID+""+timestamp,
                "value" : "Checkbox",
                "class" : "Checkbox RunButtonTrigger"
              },tdNode);
              // create checkbox widget
              elm._node.inputNode = new epages.widget.FormElement({ },elm._node.inputNode).elementNode;
            }
            // add item to dom
            this.containerNode.appendChild(elm._node.trNode);
          }
        }
      }
    },

    selectedItems: function () {
      // summary: returns an object array of currently selected items
      var result = {};
      for( var i=0,l=this._pager.bufferedPages.length ; i<l ; i++ ){
        var pageChilds = this._pager.bufferedPages[i];
        // get checked items
        dojo.forEach(pageChilds,function(el){
          if(el._node.inputNode.checked){
            result[el._data.ObjectID]=el._data;
          }
        });
      }
      return result; // Object[]
    },

    _setCheckedStatus: function(/*FormElement*/ input,/*boolean*/ checked,/*boolean?*/skipHighlight) {
      // summary: sets checked status on input field and highlights changes
      var statusChanged = input.checked != checked;
      input.checked = checked;
      // needed that for the ContentList widget (row selection)
      if($$(input.id)) {
        $$(input.id).setChecked(checked);
      }
      if(!skipHighlight) {
        // always remove highlight!
        if(checked && statusChanged) {
          dojo.addClass(input.parentNode.parentNode, "RowSelected");
        }else {
          dojo.removeClass(input.parentNode.parentNode, "RowSelected");
        }
      }
    },

    _setAllVisible: function(/*Object*/ evt) {
      // summary: sets all currently shown item checkboxes to the
      // same checked-state as the check-all checkbox
      var checked = evt.target.checked;
      var items = this._childsOnPage;
      for( var i=0,iLength=items.length ; i<iLength ; i++ ) {
        var item = items[i];
        this._setCheckedStatus(item._node.inputNode,checked);
      }
    },

    uncheckAll : function(){
      // summary: remove checked flag from all checkbox widgets on the widget
      // remove checked from check-all checkboxes
      dojo.forEach(this._checkAllCheckbox,function(el){
        this._setCheckedStatus(el, false,true);
      },this);
      // remove checked from item checkboxes
      for( var i=0,l=this._pager.bufferedPages.length ; i<l ; i++ ){
        var pageChilds = this._pager.bufferedPages[i];
        dojo.forEach(pageChilds,function(el){
          this._setCheckedStatus(el._node.inputNode, false);
        },this);
      }
    },
    startSearch : function(/*String*/searchString,/*String*/isAppointment){
      // summary: start search process and show the first page
      // initialize values
      this._pager.bufferedPages = [];
      this._checkAllCheckbox = [];
      this._pageChangeRequest.WildSearchString = searchString;
      this._pageChangeRequest.IsAppointment = isAppointment;
      this.requestPage(0,true);
    }
  }
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.product.widget.ProductPickerTree"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.widget.ProductPickerTree"] = true;
/*Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.
	epages.cartridges.de_epages.presentation.widget.ProductPickerTree
	$Revision: 1.5
	$*/
dojo.provide("epages.cartridges.de_epages.product.widget.ProductPickerTree");







dojo.declare("epages.cartridges.de_epages.product.widget.ProductPickerTree",
	[epages.widget.LocalizedWidget],
	{
		/**
		* public properties
		*/
		query								: '',
		widgetsInTemplate		: true,
		templateString:"<div class=\"Linkcreator\">\n  <div class=\"TreeContainer\">\n    <div dojoType=\"dijit.tree.ForestStoreModel\" jsId=\"productPickerTreeModel\"\n            store=\"objectStore\" query=\"${query}\"\n            rootLabel=\"Startseite\" childrenAttrs=\"children\"></div>\n    <div dojoType=\"epages.cartridges.de_epages.presentation.widget.Objecttree\"\n         dojoAttachPoint=\"tree\"\n    \n         model=\"productPickerTreeModel\"\n         query=\"${query}\"\n         label=\"{StartPage}\"\n     ></div>\n  </div>\n</div>\n",
		translationName			: dojo.moduleUrl('epages.cartridges.de_epages.product.widget','templates/translation'),
		useAbsolutePath			: false,
		url									: '?',
		selectedProduct				: undefined,

		/*
		 * private properties
		 */
		_timestamp : undefined, // make something unique

		postMixInProperties: function() {
			// summary: create object store if not already present
			// override
			this._timestamp = (new Date()).getTime();
			if(window.objectStore === undefined){
				
				window.objectStore = new epages.cartridges.de_epages.presentation.widget.Objectstore({
					jsId:      "objectStore",
					id:        "objectStore",
					queryClasses: "Product,Category",
					ignoreSubproducts: "1"
				});
			}
			if (this.query == '') {
				if(epages.topWindow && epages.topWindow.objectStore && epages.topWindow.objectStore.objectId != null){
					this.query = "{id:" + epages.topWindow.objectStore.objectId + "}";
				}else{
					this.query = "{id:" + epages.vars.CategoriesID + "}";
				}
			}
			this.inherited('postMixInProperties', arguments);
		},

		postCreate: function() {
			// summary: connect to events
			// override
			this.inherited("postCreate", arguments);
			dojo.subscribe(this.tree.id+'/select', this, function(selectedNode,a) {
				this.onSelectItem(selectedNode.item,selectedNode,a);
			});
		},
		selectedItem : function(){
			// summary: return currently selected item
			return this.selectedProduct;
		},
		onSelectItem: function(/*object*/data,item,a) {
			// summary: keep in mind which item is currently selected
			if(data.isProduct){
				this.selectedProduct = data;
			} else {
				//selected item is a folder --> no valid product
				this.selectedProduct = undefined;
			}
			dojo.publish(this.id+'/select',[this.selectedProduct]);
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.product.widget.ProductPicker"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.widget.ProductPicker"] = true;
/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.

*/
dojo.provide("epages.cartridges.de_epages.product.widget.ProductPicker");//an dieser Stelle wird das neue Widget registriert




dojo.declare("epages.cartridges.de_epages.product.widget.ProductPicker", [epages.widget.Modaldialog], {
		innerTemplatePath : dojo.moduleUrl('epages.cartridges.de_epages.product.widget', "templates/ProductPicker.html"),
		translationName   : dojo.moduleUrl('epages.cartridges.de_epages.product.widget', "templates/translation"),

		/*
		 * public properties
		*/

		searchTableHead          : undefined,  // String - column headlines
		onSubmitHandler          : undefined,  // function - custom handler which will be called when the modaldialog is going to get submitted
		requestObjectID          : undefined,  // String - #Shop.ProductFolder.ID
		options:{
				title                : '',
				width                : 450,
				height               : 250,
				content              : undefined,
				destroyWidgetOnClose : true
		}, // object - modaldialog settings

		/*
		 * private properties
		*/
		buttons                  : [], // [] - modaldialog buttons
		widgetsInTemplate        : true,

		// widget references
		_productList             : undefined,
		_productTree             : undefined,

		_viewIsTree              : true,
		_modalDialogSubmitButton : undefined, // DomNode - dom node of add button

		postMixInProperties: function() {
			// summary: set up modaldialog buttons
			this.buttons = [{
				label: '{Apply}',
				cssClass: 'Active',
				buttonId : 'modalDialogAddProductButton',
				onclick: dojo.hitch(this,this.onSubmitClick)
			 },{
				label: '{Cancel}',
				onclick: dojo.hitch(this,this.onCancelClick)
			}];
			if(this.searchTableHead === undefined) {
			this.searchTableHead = [this.translate('Name')];
			}
			dijit.Dialog.prototype.postMixInProperties.apply(this, arguments);
			this.inherited("postMixInProperties", arguments);
		},

		postCreate  : function() {
			// summary: Connect to events and create widgets
			dijit.Dialog.prototype.postCreate.apply(this, arguments);
			this.inherited("postCreate", arguments);

			this.connect(this.chooseTypeProduct.domNode,"onclick", "selectType");
			this.connect(this.chooseTypeAppointment.domNode,"onclick", "selectType");
			dojo.subscribe(this.id+"/tabChange",this,"onTabChange");

			// create search widget
			this._productList = new epages.cartridges.de_epages.product.widget.ProductPickerList({
				tableHead       : this.searchTableHead,
				requestObjectID : this.requestObjectID
			});
			// create tree widget
			this._productTree = new epages.cartridges.de_epages.product.widget.ProductPickerTree();
			// listen on select to disable submit button of modaldialog if selected item is not valid
			dojo.subscribe(this._productTree.id+'/select',this,"toggleAddButton");
			// add widgets to dom
			this.listNode.appendChild(this._productList.domNode);
			this.treeNode.appendChild(this._productTree.domNode);
		},
		show : function(){
			// summary: clean up all checkboxes
			this._productList.uncheckAll();
			this.inherited("show", arguments);
		},
		startSearch : function(evt){
			// summary: start search of productList widget
			dojo.stopEvent(evt);
			evt.returnValue = false;
			var isAppointment = this.chooseTypeAppointment.isChecked()?'1':'0';
			this._productList.startSearch(this.searchString.value,isAppointment);
		},
		selectedItems : function(){
			// summary: retrieve selected items on the current visible tab
			if(this._viewIsTree){
				var selectedItem = this._productTree.selectedItem();
				if(selectedItem){
					// convert result to look like the _productList.selectedItems() result
					var obj = {};
					obj[selectedItem.objectId] = {
						"Alias":selectedItem.alias,
						"ObjectID": selectedItem.objectId,
						"NameOrAlias":selectedItem.nameOrAlias
					};
					return obj; //Object
				} else {
					return {}; //Object
				}
			} else {
				return this._productList.selectedItems(); //Object
			}
		},
		toggleAddButton : function(/*Object*/ currentSelectedItem){
			// summary: disable submit button if selected item is not valid
			if(!this.buttons || !this.buttons[0] || !this.buttons[0].buttonId){
				return;
			}
			if(currentSelectedItem === undefined){
				this.disableButton(this.buttons[0].buttonId);
			} else  {
				this.enableButton(this.buttons[0].buttonId);
			}
		},
		onTabChange : function(/*DOMNode*/ targetTab){
			// summary: keep in mind which tab is selected to submit the correct selected items
			this._viewIsTree = targetTab==this.treeTab;
		},
		onSubmitClick : function(/*Object*/ evt){
			// summary: call custom handler and hide dialog
			if(!evt.currentTarget.className.match("Disabled")) {
				// if a custom handler is specified call it
				if(this.onSubmitHandler){
					this.onSubmitHandler(evt,this.selectedItems());
				}
				this.hide();
			}
		},
		onCancelClick : function(/*Object*/ evt){
			// summary: hide modaldialog
			this.hide();
		},
		selectType : function(/*Object*/ evt){
			// summary: change displayed text of search label
			this.searchLabel.innerHTML = evt.target.value;
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.product.widget.ProductTypeAttribute"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.widget.ProductTypeAttribute"] = true;
/*
  Copyright (c) 2006-2010, ePages GmbH
  All Rights Reserved.

  epages.cartridges.de_epages.product.widget.ProductTypeAttributeList $Revision: 1.35 $

*/
dojo.provide("epages.cartridges.de_epages.product.widget.ProductTypeAttribute");


epages.require('ep_shop_upload', 'epages.uploader');

dojo.declare("epages.cartridges.de_epages.product.widget.ProductTypeAttribute",
  [epages.widget.LocalizedWidget], {

    /**
     * public properties
     */
    alias             : "",											// string - attribute alias
    name              : "",											// string - attribute name (current language)
    data              : undefined,							// hash   - attribute data (very complex)
    attributeListId   : "",											// string - widget id of attribute list widget
    attributeNumber   : undefined,							// integer - number indentifier for the attribute
    productObjectID   : '',											// integer - object id of the product/resource

    /**
     * widget properties
     */
    templateString:"<div class=\"ProductTypeAttribute\">\n  <table class=\"InnerGrid\">\n    <tr>\n      <td class=\"Label\">\n        {Attribute}:\n      </td>\n      <td>\n        <div dojoAttachPoint=\"existingAttributeViewNode\" class=\"existingAttribute\">\n          ${name}\n        </div>\n        <div dojoAttachPoint=\"newAttributeViewNode\" class=\"newAttribute\" style=\"display:none\">\n          <input name=\"Name\"\n                 dojoAttachPoint=\"newAttributeNameNode\"\n                 disabled=\"disabled\"\n                 type=\"text\"\n                 value=\"\" />\n          <input dojoAttachPoint=\"newAttributeUsageNode\" type=\"hidden\" name=\"UseAttribute\" value=\"1\" />\n          <input dojoAttachPoint=\"newAttributeIsVisibleNode\" type=\"hidden\" name=\"VariationAttributeIsVisible\" value=\"1\" />\n          <span class=\"Type\">{Type}</span>\n          <select name=\"TypePackage\"\n                  dojoAttachPoint=\"newAttributeTypeNode\"\n                  dojoAttachEvent=\"onchange: _onAttributTypeChange\"\n                  disabled=\"disabled\"\n                  >\n            <option selected=\"selected\">{EmptyEntry}</option>\n          </select>\n          <i class=\"Sprite ico_m_delete ClickIcon\"\n             dojoAttachPoint=\"deleteNode\"\n             dojoAttachEvent=\"onclick: _onDelete\"\n             title=\"{DeleteAttribute}\"\n            ></i>\n        </div>\n      </td>\n    </tr>\n    <tr>\n      <td></td>\n      <td>\n        <div class=\"ValueContainer\" dojoAttachPoint=\"valueContainerNode\"></div>\n        <span class=\"Smaller\"\n              dojoAttachPoint=\"addNewPredefValueNode\"\n              dojoAttachEvent=\"onclick: _createNewRow\"\n              style=\"display:none\"\n              >\n        <i class=\"LeftSmallMargin Sprite ico_s_add\"></i>\n        <a href=\"#\" onclick=\"return false;\" >{addNewPredefValue}</a>\n          </span>\n      </td>\n    </tr>\n  </table>\n</div>\n",
    translationName   : dojo.moduleUrl('epages.cartridges.de_epages.product.widget', 'templates/translation'),

    /**
     * private properties
     */
    _attributeContainerTemplate    : '',         // string - attribute value container template
    _attributeTemplateMapping      : undefined,  // object - attribute value template mapping (will be filled later onPostMixInProperies)
    _deleteRowTemplate             : '',         // string - delete icon of a row template
    _fileValueTemplate             : '',         // string - template for file values
    _moreLanguagesContent          : '',         // string - more languages link template

    _rowNodes                      : undefined,  // hash - hash with row dom nodes e.g. { <rowid> : <domnode> }
    _languageContainerNodes        : undefined,  // hash - hash with language container dom nodes e.g. { <rowid> : <domnode> }
    _moreLaguagesNodes             : undefined,  // hash - hash with more languages link dom nodes e.g. { <rowid> : <domnode> }
    _deleteRowNodes                : undefined,  // hash - hash with delte row dom nodes e.g. { <rowid> : <domnode> }

    _rowCount                      : 0,          // integer - count of attribute value rows (consecutive  number / delteting a row won't decrease this number)

    _ep_connects                   : undefined,  // hash   - collection of connected events e.g. { <rowid> : <connected_event> }
    _ep_childWidgets               : undefined,  // hash   - collection of inner widgets e.g. { <rowid> : <widgets> }


    /**
     * widget life cycle
     */

    postMixInProperties: function(){
      this.inherited("postMixInProperties", arguments);
      // throw warnings
      if(!epages.vars.languages) {
        console.warn("epages.vars.languages not defined in "+this.declaredClass );
      }

      if(!epages.vars.Locale.languageId) {
        console.warn("epages.vars.Locale.languageId not defined in "+this.declaredClass );
      }

      if(epages.vars.features) {
        if(! epages.vars.features.ProductTypes) {
          console.warn("epages.vars.features.ProductTypes not defined in "+this.declaredClass );
        }
      } else {
        console.warn("epages.vars.features not defined in "+this.declaredClass );
      }

      if(! epages.vars.maxFileSize) {
        console.warn("epages.vars.maxFileSize not defined in "+this.declaredClass);
      }

      if(! epages.vars.defaultTypePackage) {
        console.warn("epages.vars.defaultTypePackage not defined in "+this.declaredClass);
      }

      // prepare templates / init vars
      this._setTemplates();
      this._ep_connects = {};
      this._ep_childWidgets = {};
      this._moreLaguagesNodes = {};
      this._languageContainerNodes = {};
      this._deleteRowNodes = {};
      this._rowNodes = {};
    },

    postCreate: function(){
      this.inherited("postCreate", arguments);

      if(this.productObjectID && (this.attributeNumber !== undefined)) {
        this.newAttributeNameNode.name = this.productObjectID + ':VariationAttributeName'+this.attributeNumber;
        this.newAttributeUsageNode.name = this.productObjectID + ':UseAttribute'+this.attributeNumber;
        this.newAttributeTypeNode.name = this.productObjectID + ':TypePackage'+this.attributeNumber;
        this.newAttributeIsVisibleNode.name = this.productObjectID + ':VariationAttributeIsVisible'+this.attributeNumber;
      }

      var attrData = this.data;

      if(attrData) {
        this._createAttributeValueNodes(attrData, true);

        if(attrData.isPreDefAttributesContainer) {																				// append new editable entry for new attribute values
          this._createNewRow();
          this.addNewPredefValueNode.style.display="";
        }
        // change type package option and select it
        this.newAttributeTypeNode.children[0].value = attrData.type;
        this.newAttributeNameNode.value = this.alias;
      } else { // attribute is new
        this.existingAttributeViewNode.style.display="none";
        this.newAttributeNameNode.disabled=false;
        this.newAttributeTypeNode.disabled=false;

        // fill attribute types
        for(var el in epages.vars.defaultTypePackage) {
          var data = epages.vars.defaultTypePackage[el];
          var selectNode= document.createElement("option");
          selectNode.value = el;
          selectNode.innerHTML = data.type_name;
          this.newAttributeTypeNode.appendChild(selectNode);
        }
        this.newAttributeViewNode.style.display="block";
      }


    },

    destroy: function() {
      this._destroyAttributeValues();
      dojo.publish(this.attributeListId+'/attributeRemoved', []);
      this.inherited("destroy", arguments);
    },

    /**
     * init functions
     */

    _setTemplates : function() {
    // summary: set template strings
    // description:
      /**
       * ==============================
       * this._attributeTemplateMapping
       * ==============================
       *
       * hash properties
       * locked       - only attribute values can be edited / predefined values can not be edited -> locked
       * lockedTransl - display translation only / can not be edited
       * edit - attribute values and predefined values can be edited
       * editTransl - attribute values and predefined values can be edited (other languages)
       *
       * placeholders
       * (%attribute_value%)   -> value of attribute
       * (%attribute_name%)    -> inputfield name for attribute (<attribute alias>:<langid>)
       * (%attribute_checked1%)-> inputfield checked string for yes radio buttons (Boolean)
       * (%attribute_checked0%)-> inputfield checked string for no radio buttons (Boolean)
       * (%attribute_file%)    -> link html for uploaded files (File, LocalizedFile)
       * (%predef_name%)       -> inputfield name for predfined choice (alias of predef choice)
       * (%predef_value%)      -> value of predef choice (e.g. name of choice)
       * (%predef_id%)         -> ObjectID of predefined choice
       * (%predef_checked%)    -> predefined choice is selected
       */

      this._attributeTemplateMapping = {
        'String'                     :	{	edit          : '<input type="text" name="AttributeName" value="(%attribute_value%)" />',
                                          locked        : '<input type="text" name="AttributeName" value="(%attribute_value%)" />'
                                        },
        'LocalizedString'            : 	{	edit          : '<input type="text" name="AttributeName:(%langid%)" value="(%attribute_value%)" /> (%native%)',
                                          locked        : '<input type="text" name="AttributeName:(%langid%)" value="(%attribute_value%)" /> (%native%)'
                                        },
        'PreDefString'               :	{	edit          : '<input type="radio" name="RadioAttributeName" value="(%attribute_value%)" (%predef_checked%) /> <input type="text" name="AttributeName" value="(%predef_value%)" />',
                                          locked        : '<input type="radio" name="RadioAttributeName" value="(%attribute_value%)" (%predef_checked%) id="(%attribute_name%)(%predef_id%)" /> <label for="(%attribute_name%)(%predef_id%)">(%predef_value%)</label>'
                                        },
        'PreDefLocalizedString'      :	{	edit          : '<input type="radio" name="RadioAttributeName:(%langid%)" value="(%attribute_value%)" (%predef_checked%) /> <input type="text" name="AttributeName:(%langid%)" value="(%predef_value%)" /> (%native%)',
                                          editTransl    : '<span class="RadioSpacer"></span> <input type="text" name="AttributeName:(%langid%)" value="(%predef_value%)" /> (%native%)',
                                          locked        : '<input type="radio" name="RadioAttributeName:(%langid%)" value="(%attribute_value%)" (%predef_checked%) id="(%attribute_name%)(%predef_id%)" /> <label for="(%attribute_name%)(%predef_id%)">(%predef_value%)</label>'
                                        },
        'PreDefMultiString'          :	{	edit          : '<input type="checkbox" name="CheckboxAttributeName:(%langid%)" value="(%attribute_value%)" (%predef_checked%) /> <input type="text" name="AttributeName" value="(%predef_value%)" />',
                                          editTransl    : '<span class="CheckboxSpacer"></span> <input type="text" name="AttributeName" value="(%predef_value%)" />',
                                          locked        : '<input type="checkbox" name="CheckboxAttributeName:(%langid%)" value="(%attribute_value%)" (%predef_checked%) id="(%attribute_name%)(%predef_id%)" /> <label for="(%attribute_name%)(%predef_id%)">(%predef_value%)</label>'
                                        },
        'PreDefMultiLocalizedString' :	{	edit          : '<input type="checkbox" name="CheckboxAttributeName" value="(%attribute_value%)" (%predef_checked%) /> <input type="text" name="AttributeName:(%langid%)" value="(%predef_value%)" /> (%native%)',
                                          editTransl    : '<span class="CheckboxSpacer"></span> <input type="text" name="AttributeName:(%langid%)" value="(%predef_value%)" />',
                                          locked        : '<input type="checkbox" name="CheckboxAttributeName" value="(%attribute_value%)" (%predef_checked%) id="(%attribute_name%)(%predef_id%)" /> <label for="(%attribute_name%)(%predef_id%)">(%predef_value%)</label>'
                                        },
        'PreDefCustomerString'       :	{	edit          : '<input type="checkbox" name="CheckboxAttributeName" value="(%attribute_value%)" (%predef_checked%) /> <input type="text" name="AttributeName:(%langid%)" value="(%predef_value%)" /> (%native%)',
                                          editTransl    : '<span class="RadioSpacer"></span> <input type="text" name="AttributeName:(%langid%)" value="(%predef_value%)" />',
                                          locked        : '<input type="checkbox" name="CheckboxAttributeName" value="(%attribute_value%)" (%predef_checked%) id="(%attribute_name%)(%predef_id%)" /> <label>(%predef_value%)</label>'
                                        },
        'Integer'                    :	{	edit          : '<input type="text" name="AttributeName" value="(%attribute_value%)" />',
                                          locked        : '<input type="text" name="AttributeName" value="(%attribute_value%)" />'
                                        },
        'Float'                      :	{	edit          : '<input type="text" name="AttributeName" value="(%attribute_value%)" />',
                                          locked        : '<input type="text" name="AttributeName" value="(%attribute_value%)" />'
                                        },
        'Boolean'                    :	{	edit          : '<input type="radio" name="AttributeName_'+this.attributeNumber+'" value="1" id="BoolAttr_'+this.attributeNumber+'_1" (%attribute_checked1%) /><label for="BoolAttr_'+this.attributeNumber+'_1">'+this.translate("Yes")+'</label><input type="radio" name="AttributeName_'+this.attributeNumber+'" value="0" id="BoolAttr_'+this.attributeNumber+'_0" (%attribute_checked0%) /><label for="BoolAttr_'+this.attributeNumber+'_0">'+this.translate("No")+'</label>',
                                          locked        : '<input type="radio" name="AttributeName_'+this.attributeNumber+'" value="1" id="BoolAttr_'+this.attributeNumber+'_1" (%attribute_checked1%) /><label for="BoolAttr_'+this.attributeNumber+'_1">'+this.translate("Yes")+'</label><input type="radio" name="AttributeName_'+this.attributeNumber+'" value="0" id="BoolAttr_'+this.attributeNumber+'_0" (%attribute_checked0%) /><label for="BoolAttr_'+this.attributeNumber+'_0">'+this.translate("No")+'</label>'
                                        },
        'Money'                      :	{	edit          : '<input type="text" name="AttributeName" value="(%attribute_value%)" />',
                                          locked        : '<input type="text" name="AttributeName" value="(%attribute_value%)" />'
                                        },
        'DateTime'                   :	{	edit          : '<input type="text" name="AttributeName" value="(%attribute_value%)" dojoType="epages.widget.Datetimeinput" selector="datetime" />',
                                          locked        : '<input type="text" name="AttributeName" value="(%attribute_value%)" dojoType="epages.widget.Datetimeinput" selector="datetime" />'
                                        },
        'Date'                       :	{	edit          : '<input type="text" name="AttributeName" value="(%attribute_value%)" dojoType="epages.widget.Datetimeinput" selector="date" />',
                                          locked        : '<input type="text" name="AttributeName" value="(%attribute_value%)" dojoType="epages.widget.Datetimeinput" selector="date" />'
                                        },
        'Time'                       :	{	edit          : '<input type="text" name="AttributeName" value="(%attribute_value%)" dojoType="epages.widget.Datetimeinput" selector="time" />',
                                          locked        : '<input type="text" name="AttributeName" value="(%attribute_value%)" dojoType="epages.widget.Datetimeinput" selector="time" />'
                                        },
        'File'                       :	{	edit          : '(%attribute_file%) <input type="text" name="AttributeName" id="DisplayFileName_Attr'+this.attributeNumber+'_(%langid%)" class="Disabled FloatLeft" value="" /> (%attribute_uploader%) <div class="Smaller AdditionalInfo">'+this.translate("MaxFileSize")+': '+epages.vars.maxFileSize+' MByte</div>',
                                          locked        : '(%attribute_file%) <input type="text" name="AttributeName" id="DisplayFileName_Attr'+this.attributeNumber+'_(%langid%)" class="Disabled FloatLeft" value="" /> (%attribute_uploader%) <div class="Smaller AdditionalInfo">'+this.translate("MaxFileSize")+': '+epages.vars.maxFileSize+' MByte</div>'
                                        },
        'LocalizedFile'              :	{	edit          : '(%attribute_file%) <input type="text" name="AttributeName:(%langid%)" id="DisplayFileName_Attr'+this.attributeNumber+'_(%langid%)" class="Disabled FloatLeft" value="" /> (%attribute_uploader%) (%native%) <div class="Smaller AdditionalInfo BottomMarginWide">'+this.translate("MaxFileSize")+': '+epages.vars.maxFileSize+' MByte</div>',
                                          locked        : '(%attribute_file%) <input type="text" name="AttributeName:(%langid%)" id="DisplayFileName_Attr'+this.attributeNumber+'_(%langid%)" class="Disabled FloatLeft" value="" /> (%attribute_uploader%) (%native%) <div class="Smaller AdditionalInfo BottomMarginWide">'+this.translate("MaxFileSize")+': '+epages.vars.maxFileSize+' MByte</div>'
                                        }
      };

      this._attributeContainerTemplate    = '(%inputhtml%) (%deleteRowTemplate%) (%moreLanguagesContent%)';
      this._deleteRowTemplate             = '<i class="Sprite ico_s_delete ClickIcon" epAttachPoint="deleteRowNode" title="'+this.translate('DeleteRow')+'"></i>';
      this._moreLanguagesContent          = '<span class="ChangeLink Smaller" epAttachPoint="moreLaguagesNode">(<a href="#" onclick="return false">'+this.translate("MoreLanguages")+'</a>)</span><div epAttachPoint="languageContainerNode" style="display:none"></div>';
      this._fileUploadTemplate            = '<input type="file" dojoAttachpoint="uploadAppletNode" id="'+this.attributeNumber+'_(%langid%)" class="ep-js" data-js="'+
                          "de_epages.presentationUiUploader({"+
                            "data:{"+
                              "ChangeAction:'UploadFiles',"+
                              "UseMediaGallery:0,"+
                              "ObjectID:"+this.productObjectID+
                            "},"+
                            "callback:function(data){"+
                              "if( data = data[ data.length-1 ].success ){"+
                                "jQuery('#DisplayFileName_Attr"+this.attributeNumber+"_(%langid%)')"+
                                  ".val(data.uploadedObjectFile);"+
                              "}"+
                            "}"+
                          "})"+
                          ".parent()"+
                          ".addClass('FloatLeft EnableHover')"+
                          '"/>';
      this._fileValueTemplate             = '<span class="Smaller" id="Link_Attr'+this.attributeNumber+'_(%langid%)"><a target="_blank" href="(%file%)">(%value%)</a>'+
                                            '<span dojoType="epages.widget.DeleteFileOnServer" '+
                                            '      class="LeftMarginWide"'+
                                            '      fileAttribute="(%attribute_alias%)"'+
                                            '      languageId="(%langid%)"'+
                                            '      filePath="(%file%)"'+
                                            '      fileName="(%value%)"'+
                                            '      confirm="1"'+
                                            '      objectId="(%product_id%)"'+
                                            '      onsuccess="dojo.addClass($(\'Link_Attr'+this.attributeNumber+'_(%langid%)\'),\'HideElement\');" ></span></span><br />';
    },

    /**
     * build functions
     */

    _createAttributeValueNodes : function(attributeData, islocked) {
    // summary: generate nodes and event handler of attribute values
      if(attributeData.preDefAttributes !== undefined || !attributeData.isPreDefAttributesContainer) {	// skip PreDefAttributesContainer without predefined attributes
        // init vars
        var currentLanguageId = epages.vars.Locale.languageId;
        var attrValueHtml = "";

        // choose template version (locked or edit version)
        var attrValueTemplate = (islocked) ? this._attributeTemplateMapping[attributeData.type].locked :	this._attributeTemplateMapping[attributeData.type].edit;

        // calculate number of iterations
        var numberOfLoops = 1;
        var countPredefAttributes = 0;
        if(attributeData.preDefAttributes) {
          countPredefAttributes = attributeData.preDefAttributes.length;
          numberOfLoops = countPredefAttributes;																					// change number of iterations to number of predfined attribute values
        }

        // iterate
        for(var i = 0; i< numberOfLoops; i++) {																						// multiple choices are needed by any preDefAttribute type
          // prepare container template (localized or not)

          attrValueHtml = this._attributeContainerTemplate;

          // generate input html code for current language
          var predefined = (countPredefAttributes) ? attributeData.preDefAttributes[i] : undefined;
          var predefValueKey = "value"+':'+currentLanguageId;
          var attributeValue= "";
          var attributeIsChecked1 = "";
          var attributeIsChecked0 = "";

          if(attributeData.value !== undefined) {
            attributeValue = attributeData.value;

            if(attributeData.value) {
              attributeIsChecked1 = 'checked="checked"';
            } else {
              attributeIsChecked0 = 'checked="checked"';
            }

          } else if(attributeData['value:'+currentLanguageId]) {
            attributeValue = attributeData['value:'+currentLanguageId];
          }

          var predefIsChecked = "";
          if(attributeData.values) {
            for(var el in attributeData.values) {
              if(attributeData.values[el] == predefined.id) {
                predefIsChecked='checked="checked"';
              }
            }
          }

          var attributeFile = "";
          if(attributeData.file) {
            var fileTmpl = $TMPL(this._fileValueTemplate, {
              attribute_alias : this.alias,
              attribute_id    : attributeData.id,
              langid          : currentLanguageId,
              file            : attributeData.file,
              value           : attributeData.value,
              product_id      : attributeData.productId
            }, false);
            attributeFile = fileTmpl.generateOutput();
          }

          var uploader = "";
          var uploadTmpl = $TMPL(this._fileUploadTemplate, {
            attribute_alias : this.alias,
            attribute_id    : attributeData.id,
            langid          : currentLanguageId,
            file            : attributeData.file,
            value           : attributeData.value,
            product_id      : attributeData.productId
          }, false);
          uploader = uploadTmpl.generateOutput();

          if(attributeData['file:'+currentLanguageId]) {
            var fileTmpl = $TMPL(this._fileValueTemplate, {
              attribute_alias : this.alias,
              attribute_id    : attributeData.id,
              langid          : currentLanguageId,
              file            : attributeData['file:'+currentLanguageId],
              value           : attributeData['value:'+currentLanguageId],
              product_id      : attributeData.productId
            }, false);
            attributeFile = fileTmpl.generateOutput();
          }

          var inputHtml = this._createInput({
            templatestring    : attrValueTemplate,
            alias             : this.alias,
            langid            : currentLanguageId,
            predef_name       : (predefined) ? predefined.alias : undefined,
            predef_id         : (predefined) ? predefined.id : undefined,
            predef_value      : (predefined) ? predefined[predefValueKey] : undefined,
            predef_checked    : predefIsChecked,
            attribute_value   : attributeValue,
            attribute_checked1: attributeIsChecked1,
            attribute_checked0: attributeIsChecked0,
            attribute_file    : attributeFile,
            attribute_id      : attributeData.id,
            attribute_uploader: uploader
          });

          var moreLanguagesContentHtml = (attributeData.isLocalized && !(attributeData.isPreDefAttributesContainer && islocked)) ? this._moreLanguagesContent : "";		// don't show translations on locked predfined rows
          var deleteRowTemplateHtml = (!islocked) ? this._deleteRowTemplate : "";																				// don't show delete button on locked rows

          var attrValueHtml = $TMPL(attrValueHtml , {
            inputhtml : inputHtml,
            moreLanguagesContent : moreLanguagesContentHtml,
            deleteRowTemplate: deleteRowTemplateHtml
          }, false).generateOutput();

          // generate and insert as node (insert row)
          var attributeValueNode = document.createElement("div");
          attributeValueNode.innerHTML = attrValueHtml;
          if(islocked && predefined && predefined.id) {
            dojo.attr(attributeValueNode, "predefobjectid", predefined.id);
          }
          this._rowNodes[this._rowCount] = attributeValueNode;																													// save row dom node refernce
          this.valueContainerNode.appendChild(attributeValueNode);																											// append

          // append events (delete button)
          this._ep_connects[this._rowCount] = {};
          if(!islocked) {																																																//  locked rows can not be deleted
            var deleteRowNodeNodeArray= dojo.query('[epAttachPoint=deleteRowNode]',attributeValueNode);
            if(deleteRowNodeNodeArray.length) {
              this._deleteRowNodes[this._rowCount] = deleteRowNodeNodeArray[0];
              this._deleteRowNodes[this._rowCount].setAttribute("ep_rowcount", this._rowCount);
              this._ep_connects[this._rowCount]['deleteRowNode'] = dojo.connect(this._deleteRowNodes[this._rowCount], "onclick", this, "_onDeleteRow");
            }
          }

          // generate inputs -> other languages (except predefined locked rows)
          if(attributeData.isLocalized && !(attributeData.isPreDefAttributesContainer && islocked)) {
            var nodeArray= dojo.query('[epAttachPoint=languageContainerNode]', attributeValueNode);
            if(nodeArray.length) {
              this._languageContainerNodes[this._rowCount] = nodeArray[0];
              var languageInputs = "";
              for(var langkey in epages.vars.languages) {
                if(langkey != currentLanguageId) {

                  // template switch - use template version for translations
                  var tempAttrValueTemplate = "";
                  if(islocked) {
                    tempAttrValueTemplate = attrValueTemplate;
                  } else {
                    tempAttrValueTemplate = (this._attributeTemplateMapping[attributeData.type].editTransl) ? this._attributeTemplateMapping[attributeData.type].editTransl : attrValueTemplate;
                  }
                  predefValueKey = "value"+':'+langkey; 																	// use current langkey in predefValueKey
                  var attributeValue= "";
                  if(attributeData.value) {
                    attributeValue = attributeData.value;
                  } else if(attributeData['value:'+langkey]) {
                    attributeValue = attributeData['value:'+langkey];
                  }

                  var uploader = "";
                  var uploadTmpl = $TMPL(this._fileUploadTemplate, {
                    attribute_alias : this.alias,
                    attribute_id    : attributeData.id,
                    langid          : langkey,
                    file            : attributeData.file,
                    value           : attributeData.value,
                    product_id      : attributeData.productId
                  }, false);
                  uploader = uploadTmpl.generateOutput();

                  var attributeFile = "";
                  if(attributeData['file:'+langkey]) {
                    var fileTmpl = $TMPL(this._fileValueTemplate, {
                      attribute_alias : this.alias,
                      attribute_id    : attributeData.id,
                      langid          : langkey,
                      file            : attributeData['file:'+langkey],
                      value           : attributeData['value:'+langkey],
                      product_id      : attributeData.productId
                    }, false);
                    attributeFile = fileTmpl.generateOutput();
                  }

                  var langData = epages.vars.languages[langkey];
                  var inputHtml = this._createInput({
                    templatestring: tempAttrValueTemplate,
                    alias           : this.alias,
                    langid          : langkey,
                    'native'        : '<span class="Smaller">(' + langData['native'] + ')</span>',
                    predef_name     : (predefined) ? predefined.alias : undefined,
                    predef_id       : (predefined) ? predefined.id : undefined,
                    predef_value    : (predefined) ? predefined[predefValueKey] : undefined,
                    attribute_value : attributeValue,
                    attribute_file  : attributeFile,
                    predef_checked  : predefIsChecked,
                    attribute_id    : attributeData.id,
                    attribute_uploader : uploader
                  });
                  languageInputs += '<div class="LanguageInput">'+inputHtml+'</div>';
                }
              }
              this._languageContainerNodes[this._rowCount].innerHTML=languageInputs;
            }

            // append events (more languages link)
            var mLanguagesNodeArray= dojo.query('[epAttachPoint=moreLaguagesNode]',attributeValueNode);
            if(mLanguagesNodeArray.length) {
              this._moreLaguagesNodes[this._rowCount] = mLanguagesNodeArray[0];
              this._moreLaguagesNodes[this._rowCount].setAttribute("ep_rowcount", this._rowCount);
              this._ep_connects[this._rowCount]['languagesNode'] = dojo.connect(this._moreLaguagesNodes[this._rowCount], "onclick", this, "_onShowLanguages");
            }
          }
          var innerWidgets = dojo.parser.parse(this.valueContainerNode);	//create inner widgets
          this._ep_childWidgets[this._rowCount] = [];
          var _this = this;
          dojo.forEach(innerWidgets, function(el) {
            _this._ep_childWidgets[_this._rowCount].push(el);
          });

          this._rowCount++;
        }
      }
    },

    _createInput : function(/* object */opt) {
      // summary: creates a single input element
      // opt: {
      //         templatestring    - input template string
      //         alias             - alias of attribute
      //         langid            - languageid of input field
      //         native            - native name of language
      //         predef_name       - name for predefined choice input field
      //         predef_id         - ObjectID of predefined choice
      //         predef_value      - value of predefined choice (e.g. name of choice)
      //         predef_checked    - predefined choice is selected
      //         attribute_value   - value of attribute
      //         attribute_name    - inputfield name for attribute (<attribute alias>:<langid>)
      //         attribute_checked1- inputfield checked string for yes radio buttons (Boolean)
      //         attribute_checked0- inputfield checked string for no radio buttons (Boolean)
      //         attribute_file    - link html for uploaded files (File, LocalizedFile)
      //      }
      var inputTmpl = $TMPL(opt.templatestring , {
          langid            : opt.langid,
          attribute_name    : opt.alias+':'+opt.langid,
          'native'          : (opt['native']) ? opt['native'] : "",
          predef_name       : (opt.predef_name) ? opt.predef_name : "",
          predef_id         : (opt.predef_id) ? opt.predef_id : "",
          predef_value      : (opt.predef_value) ? opt.predef_value : "",
          predef_checked    : (opt.predef_checked) ? opt.predef_checked : "",
          attribute_value   : (opt.attribute_value) ? opt.attribute_value : "",
          attribute_checked1: (opt.attribute_checked1) ? opt.attribute_checked1 : "",
          attribute_checked0: (opt.attribute_checked0) ? opt.attribute_checked0 : "",
          attribute_file    : (opt.attribute_file) ? opt.attribute_file : "",
          attribute_uploader: (opt.attribute_uploader) ? opt.attribute_uploader : "",
          attribute_id      : (opt.attribute_id) ? opt.attribute_id : ""
      }, false);
      return inputTmpl.generateOutput();
    },

    /**
     * events
     */

    _onAttributTypeChange: function(evt) {
      var selectNode = evt.currentTarget;
      var defaultTypePackage = epages.vars.defaultTypePackage;
      if(defaultTypePackage[selectNode.value]) {
        // destory old content
        this._destroyAttributeValues();

        this.data = defaultTypePackage[selectNode.value];
        // create new value nodes / rows
        this._createAttributeValueNodes(this.data, true);
        if(this.data.isPreDefAttributesContainer) {								// append new editable entry for new attribute values
          this._createNewRow();
          this.addNewPredefValueNode.style.display="";
        } else {
          this.addNewPredefValueNode.style.display="none";
        }
      }
    },

    _onShowLanguages: function(evt) {
      // summary: change display of languages nodes
      var myIndex = evt.currentTarget.getAttribute("ep_rowcount");
      evt.currentTarget.style.display="none";
      dojo.fx.wipeIn({ node: this._languageContainerNodes[myIndex],  duration: 200}).play();
    },

    _onDeleteRow: function(evt) {
      // summary: delete specific row
      var myRowIndex = evt.currentTarget.getAttribute("ep_rowcount");
      var rowNode = this._rowNodes[myRowIndex];

      // detach events
      for(var el in this._ep_connects[myRowIndex]) {
        dojo.disconnect(this._ep_connects[myRowIndex][el]);
      }
      delete this._ep_connects[myRowIndex];

      // destroy inner widgets
      var rowWidgets = this._ep_childWidgets[myRowIndex];
      for(var el in rowWidgets) {
        var widget = rowWidgets[el];
        if(widget) {
          widget.destroy();
        }
        delete this._ep_childWidgets[myRowIndex];
      }

      // remove row dom node
      rowNode.parentNode.removeChild(rowNode);
    },

    _onDelete: function(evt) {
      // summary: delete / destroy widget
      this.destroy();
    },

    /**
     * other functions
     */

    _createNewRow: function() {
    // summary: create a new row with empty input fields for new predef attribute choices
      var attrData = this.data;
      var currentLanguageId = epages.vars.Locale.languageId;
      var attrOptions = {
        type                        : attrData.type,
        isLocalized                 : attrData.isLocalized,
        isPreDefAttributesContainer : true,
        preDefAttributes            : []
      };

      var emptyPredefAttr = {
        alias: '-alias:new-',
        id: '-id:new-'
      };

      for(var langkey in epages.vars.languages) {
        attrOptions['name:'+langkey] = "";
        if(currentLanguageId != langkey && attrData.isLocalized) {
          emptyPredefAttr['value:'+langkey] = "";
        }
      }
      attrOptions.preDefAttributes.push(emptyPredefAttr);
      this._createAttributeValueNodes(attrOptions, false);

    },

    _destroyAttributeValues : function() {
    // summary: detach all connects / destroy all value nodes
      for(var el in this._ep_connects) {
        var rowconnects = this._ep_connects[el];
        for(var connection in rowconnects) {
          dojo.disconnect(rowconnects[connection]);
        }
        delete this._ep_connects[el];
      }

      // destroy inner widgets
      for(var key in this._ep_childWidgets) {
        var cWidgets = this._ep_childWidgets[key];
        for(var el in cWidgets) {
          var widget = cWidgets[el];
          if(widget) {
            widget.destroy();
          }
          delete this._ep_childWidgets[key];
        }
      }

      // destroy dom nodes
      this.valueContainerNode.innerHTML="";
    }

});

}

if(!dojo._hasResource["epages.cartridges.de_epages.product.widget.ProductTypeAttributeList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.widget.ProductTypeAttributeList"] = true;
/*
	Copyright (c) 2006-2010, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.product.widget.ProductTypeAttributeList $Revision: 1.18 $

*/
dojo.provide("epages.cartridges.de_epages.product.widget.ProductTypeAttributeList");



dojo.declare("epages.cartridges.de_epages.product.widget.ProductTypeAttributeList",
	[epages.widget.LocalizedWidget], {

		/**
		 * public properties
		 */
		productTypeId     : '',														// string - id of product type
		productTypeName   : '',														// string - name of product type
		productTypeData   : undefined,										// object - product type data
		url               : '?',													//
		changeAction      : 'SaveProductType',						// string - name of change action
		viewAction        : 'View-JSON-ProductTypeData',	// string - name of view action
		objectId          : '',														// string - id of ressource
		currentLanguageId : '',					// string - id of current (display) language
		showVisibileOnly  : '0',				// string - flag to hide not visible attributes
		maxCountAttributes: 0,					// integer - numer of max possible attributes


		/**
		 * public properties
		 */
		_ep_childWidgets  : undefined,	// array   - array with child widgets
		_countAttributes  : 0,					// integer - current count attributes


		/**
		 * widget properties
		 */
		templateString:"<div class=\"ProductTypeAttributeList\">\n  <h2>{ProductType} \"<span dojoAttachPoint=\"nameNode\">{NewSetName}</span>\"</h2>\n  <div class=\"DialogMessage MessageInfo\" id=\"AttributeNameWarning\">\n  \t{AttributeNameWarning}\n  </div>\n  <div dojoAttachPoint=\"containerNode\" ></div>\n  <div dojoAttachEvent=\"onclick:onAddNewAttribute\"\n        dojoAttachPoint=\"newAttributeNode\"\n        class=\"AddNewAttribute ClickIcon EnableHover\"><i class=\"Sprite ico_s_add\"></i><a href=\"#\" onclick=\"return false;\">{AddNewAttribute}</a></div>\n  <div class=\"DialogMessage MessageInfo\" style=\"display:none;\" dojoAttachPoint=\"featureLimitExeededNode\">\n    <h3>{Notification}</h3>\n    <p class=\"Smaller\">{AttributesFeatureLimitExeeded}<br />\n      {MaxCountAttributes}: ${maxCountAttributes}\n    </p>\n  </div>\n</div>\n",
		translationName: dojo.moduleUrl('epages.cartridges.de_epages.product.widget', 'templates/translation'),

		postMixInProperties: function(){
			this.inherited("postMixInProperties", arguments);
			this._ep_childWidgets = [];
			this.productTypeData = window.epages.vars.productTypeData;
			this.productTypeName = this.productTypeData.name;
			this.showVisibileOnly = epages.string.toBoolean(this.showVisibileOnly);

			if(epages.vars.features) {
				if(! epages.vars.features.ProductTypeAttributes) {
					console.warn("epages.vars.features.ProductTypeAttributes not defined in "+this.declaredClass );
				}
			} else {
				console.warn("epages.vars.features not defined in "+this.declaredClass );
			}
			this.maxCountAttributes = parseInt(epages.vars.features.ProductTypeAttributes.FeatureMaxValue);
		},

		postCreate: function(){
			this.inherited("postCreate", arguments);
			if(window.epages.vars.productTypeData) {
				console.warn('epages.vars.productTypeData not defined in '+this.declaredClass);
				this.productTypeData = window.epages.vars.productTypeData;
				this.productTypeName = this.productTypeData.name;
				this._setUpContent();
			}	else {
				this.onChangeProductType(this.productTypeId);
			}

			dojo.subscribe(this.id+"/attributeRemoved", this, "onAttributeRemoved");
			dojo.subscribe(this.id+"/changeProductType", this, "onChangeProductType");
			dojo.subscribe(this.id+'/changeProductTypeName', this, 'onChangeProductTypeName');
		},

		_setUpContent: function() {
		// summary: create attribute widgets / display feature count message
			for(var key in this.productTypeData.attributes) {
				var data = this.productTypeData.attributes[key];
				if(data.isVisible == "1" || !this.showVisibileOnly) {
					var attributeWidget = new epages.cartridges.de_epages.product.widget.ProductTypeAttribute({
						name : data['name:'+this.currentLanguageId],
						alias : key,
						data: data,
						attributeListId : this.id,
						productObjectID : this.objectId,
						attributeNumber : this._countAttributes
					});
					if(attributeWidget) {
						this.containerNode.appendChild(attributeWidget.domNode);
						this._ep_childWidgets.push(attributeWidget);
					}
				}
				this._countAttributes++;
				if(this._countAttributes >= this.maxCountAttributes ) {
					this.newAttributeNode.style.display="none";
					this.featureLimitExeededNode.style.display = "";
				} else {
					this.newAttributeNode.style.display="";
					this.featureLimitExeededNode.style.display = "none";
				}
			}
		},

		onChangeProductTypeName: function(/* string */name ) {
		// summary: change the name node of productype
			this.nameNode.innerHTML = name;
			document.getElementById("AttributeNameWarning").style.display="none";
		},

		onAddNewAttribute: function() {
		// summary: add ne (empty) attribute widget
			var attributeWidget = new epages.cartridges.de_epages.product.widget.ProductTypeAttribute({
				attributeListId : this.id,
				attributeNumber : this._countAttributes,
				productObjectID : this.objectId
			});
			if(attributeWidget) {
				this._ep_childWidgets.push(attributeWidget);
				this.containerNode.appendChild(attributeWidget.domNode);
				this._countAttributes++;
				if(this._countAttributes >= this.maxCountAttributes ) {
					this.newAttributeNode.style.display="none";
					this.featureLimitExeededNode.style.display = "";
				} else {
					this.newAttributeNode.style.display="";
					this.featureLimitExeededNode.style.display = "none";
				}
			}
		},

		onAttributeRemoved: function(/* object */ opt) {
		// summary: message function - decrease counter ( show / hide feature limit message)
			this._countAttributes--;
			if(this._countAttributes >= this.maxCountAttributes ) {
				this.newAttributeNode.style.display="none";
				this.featureLimitExeededNode.style.display = "";
			} else {
				this.newAttributeNode.style.display="";
				this.featureLimitExeededNode.style.display = "none";
			}
		},

		onChangeProductType : function(/* string*/ productTypeId) {
		// summary: load new product type data by product type id
			var formData = {
				'ChangeAction' : this.changeAction,
				'ViewAction' : this.viewAction,
				'ObjectID' : this.objectId,
				'Class' : productTypeId
			};

			var _this = this;
			var request = new dojo.xhrPost({
				url     : this.url,
				Accept  : 'text/x-json',
				content : formData,
				load    : function(response, args) {
					_this._setNewProductType(response, args);
				},
				error   : this._loadError
			});
		},

		_loadError: function (response, args) {
		// summary: error callback / displays an error message
			var rm = response.message;
			var rn = response.name;
			dojo.publish("uimessage/showErrors", ["IO ERROR", 'loading product type data', [{
				Message : 'Could not load product type data.('+rm+')',
				Reason  : rn
			}
			]]);
			console.error(response, args);
		},

		_setNewProductType : function(response, args) {
		// summary: prepare and setup new prdouctype data / widgets
			this._destroyChildWidgets();
			response = response.replace(/<!--.*-->/g, "");		// remove comments from pagetype
			this.productTypeData = dojo.fromJson(response);
			this._setUpContent();
		},

		_destroyChildWidgets : function() {
		// summary: destroys all childwidgets
			for(var el in this._ep_childWidgets) {
				this._ep_childWidgets[el].destroy();
				delete this._ep_childWidgets[el];
			}
			this._ep_childWidgets = [];
		},

		step: function( step , ObjectID ){
			var saveSubscribe;
			if(step && step.stepData && step.stepData.TemplateName == "Content-Attributes") {
				saveSubscribe = dojo.subscribe( 'ResourceWizard/saveFinished', dojo.hitch( this, function(resultData){
					if(resultData && resultData.Attributes) {
						var attributeWidgets = this._ep_childWidgets;
						var preDefValueObjects = {};
						if(attributeWidgets) {
							// for all attributes that were created by the wizard's changeaction
							dojo.forEach(resultData.Attributes, function(att){
								// for all widgets related to each attribute
								dojo.forEach(attributeWidgets, function(widget){
									var attrType = widget.data.type;
									// depending on the attribute type
									if(widget.newAttributeNameNode.value == att.Alias) {
										// found the correct correlated attribute
										// update widget data (for later value-assignment to resource object)
										widget.data.id = att.ObjectID;
										widget.alias = att.Alias;

										var result; // JSON result
										if(attrType == "PreDefString") {
											// get value nodes of this attribute
											dojo.forEach(widget.valueContainerNode.children, function(divNode) {
												// all inputs in that div
												dojo.query("input[name^='AttributeName'][type$='text']", divNode).forEach(function(input) {
													// send save request for this attribute containing the values
													var params = {
														'ChangeAction'	 : 'SavePreDefAttributes',
														'ObjectID'			 : att.ObjectID,
														'NewAlias'			 : att.Alias,
														'NewPosition'		: 9999,
														'NewValueString' : input.value,
														'Save'					 : 1
													};
													var result = new epages.io.Json().loadSync('?', params);
													if(result && result.error && result.error.data){
														console.warn("todo: handle error", result.error.data);
													} else {
														if(result && result.data) {
															preDefValueObjects[input.value] = result.data.PreDefAttributeChildren[input.value];
															dojo.attr(divNode, "predefobjectid", result.data.PreDefAttributeChildren[input.value]);
														}
													}
												});
											});
										}
										else if (attrType == "PreDefMultiString") {
											// get value nodes of this attribute
											// foreach value block of the attributewidget
											dojo.forEach(widget.valueContainerNode.children, function(divNode) {
												dojo.query("input[name^='AttributeName'][type$='text']", divNode).forEach(function(inputNode) {
													// request skeleton
													var params = {
														'ChangeAction'	 : 'SavePreDefAttributes',
														'ObjectID'			 : att.ObjectID,
														'NewAlias'			 : inputNode.value,
														'NewValueString' : inputNode.value, // only one value for both in wizard
														'NewPosition'		: 9999,
														'Save'					 : 1,
														'ErrorAction'		: 'JSONViewResponse'
													};
													// send save request for this attribute containing the values
													var result = new epages.io.Json().loadSync('?', params);
													if(result && result.error && result.error.data){
														console.warn("todo: handle error", result.error.data);
													} else {
														if(result && result.data) {
															preDefValueObjects[params.NewAlias] = result.data.PreDefAttributeChildren[params.NewAlias];
															dojo.attr(divNode, "predefobjectid", result.data.PreDefAttributeChildren[params.NewAlias]);
														}
													}
												});
											});
										}
										else if (attrType == "PreDefLocalizedString" || attrType == "PreDefMultiLocalizedString" || attrType == "PreDefCustomerString") {
											// get value nodes of this attribute
											// foreach value block of the attributewidget
											dojo.forEach(widget.valueContainerNode.children, function(divNode) {
												var inputNodes = dojo.query("input[name^='AttributeName'][type$='text']", divNode);
												// primary language input
												var firstInputNode = inputNodes.shift();
												var nameValues = firstInputNode.name.split(':');
												if(nameValues[0] != "AttributeName") {
													console.warn("error: attribute name did not match", nameValues[0]);
													return;
												}
												// request skeleton
												var params = {
													'ChangeAction'	 : 'SavePreDefAttributes',
													'ObjectID'			 : att.ObjectID,
													'NewAlias'			 : undefined,
													'NewPosition'		: 9999,
													'Save'					 : 1,
													'ErrorAction'		: 'JSONViewResponse'
												};
												// multiple value fields as arrays
												var NewValueLocStrings = [];
												var NewLanguageIDs = [];
												// fetch langid
												NewLanguageIDs.push(nameValues[1]);
												// assign value to alias (first language-assigned name used as alias) and push value (for primary lang value)
												NewValueLocStrings.push(firstInputNode.value);
												params.NewAlias = firstInputNode.value;

												// all further inputs for all the other languages:
												inputNodes.forEach(function(input) {
													var nameValues = input.name.split(':');
													if(nameValues[0] == "AttributeName") {
														var valueLangId = nameValues[1];
														NewValueLocStrings.push(input.value);
														NewLanguageIDs.push(valueLangId);
													}
												});
												params.NewValueLocString = NewValueLocStrings;
												params.NewLanguageID = NewLanguageIDs;
												// send save request for this attribute containing the values
												var result = new epages.io.Json().loadSync('?', params);
												if(result && result.error && result.error.data){
													console.warn("todo: handle error", result.error.data);
												} else {
													if(result && result.data) {
														preDefValueObjects[params.NewAlias] = result.data.PreDefAttributeChildren[params.NewAlias];
														dojo.attr(divNode, "predefobjectid", result.data.PreDefAttributeChildren[params.NewAlias]);
													}
												}
											});
										}
									} // end if attr type
								});
							});
						}
						// assign selected values to the resource
						if(this.containerNode.children && this.containerNode.children.length > 0) {
							var params = {
								'ChangeAction'	 : 'Save',
								'ObjectID'			 : ObjectID,
								'ErrorAction'		: 'JSONViewResponse',
								'HandleFilesAsStrings' : 1
							};
							var altAttributeIDs = [];
							dojo.forEach(this.containerNode.children, function(widgetNode) {
								var widget = $$(widgetNode.id);
								if(widget && widget.alias && widget.data && widget.data.id) {
									var attrType = widget.data.type;
									// fetch the selected / entered value and assign it to the resource object
									if (attrType == "String" || attrType == "Money" ||
											attrType == "Integer" || attrType == "Float" ||
											attrType == "DateTime" || attrType == "Date" || attrType == "Time" || attrType == "File") {
										params[widget.alias] = [];
										dojo.forEach(widget.valueContainerNode.children, function(divNode) {
											dojo.query("input[name^='AttributeName'][type$='text']", divNode).forEach(function(input) {
												params[widget.alias].push(input.value);
											});
										});
									}
									else if (attrType == "Boolean") {
										params[widget.alias] = [];
										dojo.forEach(widget.valueContainerNode.children, function(divNode) {
											dojo.query("input[name^='AttributeName'][type$='radio']", divNode).forEach(function(input) {
												if(input.checked) {
													params[widget.alias].push(input.value);
												}
											});
										});
									}
									else if(attrType == "LocalizedString"	|| attrType == "LocalizedFile") {
										// needs LanguageID value for each string!
										params[widget.alias] = [];
										params['LanguageID'] = [];
										dojo.forEach(widget.valueContainerNode.children, function(divNode) {
											dojo.query("input[name^='AttributeName'][type$='text']", divNode).forEach(function(input) {

												var nameValues = input.name.split(':');
												if(nameValues[0] != "AttributeName") {
													console.warn("error: attribute name did not match", nameValues[0]);
													return;
												}
												var valueLangId = nameValues[1];
												params[widget.alias].push(input.value);
												params['LanguageID'].push(valueLangId);
											});
										});
									}
									// predef radio values: we need the object ids of the predefattributes
									else if(attrType == "PreDefString" || attrType == "PreDefLocalizedString") {
										// needs LanguageID value for each string!
										params[widget.alias] = [];
										dojo.forEach(widget.valueContainerNode.children, function(divNode) {
											dojo.query("input[name^='RadioAttributeName'][type$='radio']", divNode).forEach(function(radioInput) {
												var preDefObjectID = dojo.attr(divNode, "predefobjectid");
												if(radioInput.checked && preDefObjectID) {
													params[widget.alias].push(preDefObjectID);
												}
											});
										});
									}
									// predef multi values with checkboxes
									else if(attrType == "PreDefCustomerString" || attrType == "PreDefMultiLocalizedString" || attrType == "PreDefMultiString") {
										params[widget.alias] = [];
										dojo.forEach(widget.valueContainerNode.children, function(divNode) {
											dojo.query("input[name^='CheckboxAttributeName'][type$='checkbox']", divNode).forEach(function(cbInput) {
												var preDefObjectID = dojo.attr(divNode, "predefobjectid");
												if(cbInput.checked && preDefObjectID) {
													params[widget.alias].push(preDefObjectID);
												} else {
													params[widget.alias].push('');
												}
											});
										});
									}

									// only add change attribute id if value will be assigned
									if(params[widget.alias] != undefined) {
										altAttributeIDs.push(widget.data.id);
									}

								} else {
									console.warn("error while assigning attribute values", "attr alias", widget.alias, "attr objectid", widget.data.id);
								}
							});
							if(altAttributeIDs.length > 0) {
								params['AltAttributeID'] = altAttributeIDs;
								// send one request for all values
								var result = new epages.io.Json().loadSync('?', params);
								if(result && result.error && result.error.data){
									console.warn("todo: handle error", result.error.data);
								}
							}
						}
					} // end if json result data
					if(saveSubscribe) {
						dojo.unsubscribe(saveSubscribe);
					}
				}));
			}
			else if(saveSubscribe) {
				dojo.unsubscribe(saveSubscribe);
			}

		}
	});


}

if(!dojo._hasResource["epages.cartridges.de_epages.product.EnableOwnPrices"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.product.EnableOwnPrices"] = true;
/*
    Copyright (c) 2006-2011, ePages GmbH
    All Rights Reserved.

    epages.cartridges.de_epages.product.EnableOwnPrices $Revision: 1.4 $
 */

dojo.provide("epages.cartridges.de_epages.product.EnableOwnPrices");

window.disablePrices = function() {
// disables all visible input fields
// enables all hidden input fields

  var priceinputs = document.getElementsByName("Price");
  for(var i=0, iLength=priceinputs.length; i<iLength; i++) {
    if(priceinputs[i].type=="hidden") {
      priceinputs[i].disabled=false;
    } else {
      priceinputs[i].disabled=true;
      priceinputs[i].className="Price Disabled";
    }
  }

  priceinputs = document.getElementsByName("ManufacturerPrice");
  for(var i=0, iLength=priceinputs.length; i<iLength; i++) {
    if(priceinputs[i].type=="hidden") {
      priceinputs[i].disabled=false;
    } else {
      priceinputs[i].disabled=true;
    }
  }

  // EPG-4144: disable taxclass select box
  taxelement = document.getElementById("TaxClass");
  taxelement.disabled=true;
  dojo.addClass(taxelement.parentNode, "Disabled");

  // disable ecopart settings
  dojo.publish("EcoParticipation/disable", []);
};

window.enablePrices = function() {
// enables all visible input fields
// disables all hidden input fields

  var priceinputs = document.getElementsByName("Price");
  for(var i=0, iLength=priceinputs.length; i<iLength; i++) {
    if(priceinputs[i].type=="hidden") {
      priceinputs[i].disabled=true;
    } else {
      priceinputs[i].disabled=false;
      priceinputs[i].className="Price";
    }
  }

  priceinputs = document.getElementsByName("ManufacturerPrice");
  for(var i=0, iLength=priceinputs.length; i<iLength; i++) {
    if(priceinputs[i].type=="hidden") {
      priceinputs[i].disabled=true;
    } else {
      priceinputs[i].disabled=false;
    }
  }

  // EPG-4144: enable taxclass select box
  taxelement = document.getElementById("TaxClass");
  taxelement.disabled=false;
  dojo.removeClass(taxelement.parentNode, "Disabled");

  // enable ecopart settings
  dojo.publish("EcoParticipation/enable", []);
};

}

